<?php
/*
* Add-on Name: Advantage Box Module
*/
if ( ! class_exists( 'St_Advantage_Box_Module' ) ) {
	class St_Advantage_Box_Module {
		function __construct() {
			add_shortcode( 'st_advantage_box_module', array( $this, 'advantage_box_module_shortcode' ) );
			add_action( 'init', array( $this, 'advantage_box_module_init' ) );
		}

		function advantage_box_module_shortcode( $atts, $content ) {
			$output                   = $advantage_box_title = $advantage_box_title_color = $advantage_box_bg = $advantage_box_bg_overlay = $module_animation = $animation = $animated = $advantage_box_title_align = $advantage_box_bg_overlay_color = $el_class = '';
			$advantage_box_title_font = $advantage_box_title_font_style = $advantage_box_title_font_size = $advantage_box_title_font_line_height = $advantage_box_title_font_letter_spacing = '';
			$advantage_box_desc_font  = $advantage_box_desc_font_style = $advantage_box_desc_font_color = $advantage_box_desc_font_size = $advantage_box_desc_font_line_height = $advantage_box_desc_font_letter_spacing = '';
			$link                     = '';
			extract( shortcode_atts( array(
				'advantage_box_title'                     => '',
				'advantage_box_bg'                        => '',
				'advantage_box_bg_overlay_color'          => '',
				'advantage_box_title_color'               => '',
				'advantage_box_title_align'               => '',
				'advantage_box_title_font'                => '',
				'advantage_box_title_font_style'          => '',
				'advantage_box_title_font_size'           => '',
				'advantage_box_title_font_line_height'    => '',
				'advantage_box_title_font_letter_spacing' => '',
				'advantage_box_desc_font'                 => '',
				'advantage_box_desc_font_style'           => '',
				'advantage_box_desc_font_color'           => '',
				'advantage_box_desc_font_size'            => '',
				'advantage_box_desc_font_line_height'     => '',
				'advantage_box_desc_font_letter_spacing'  => '',
				'link'                                    => '',
				'module_animation'                        => '',
				'el_class'                                => '',
			), $atts ) );

			$id = uniqid( 'st-advantage-box-' );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			if ( $advantage_box_title_align == 'center' ) {
				$align = 'text-center';
			} else if ( $advantage_box_title_align == 'right' ) {
				$align = 'text-right';
			} else if ( $advantage_box_title_align == 'justify' ) {
				$align = 'text-justify';
			} else {
				$align = 'text-left';
			}

			// Title font style
			$title_style = 'style="';
			if ( $title_style !== '' ) {
				$advantage_box_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $advantage_box_title_font ) : '';
				$title_style                     .= ! empty( $advantage_box_title_font_family ) ? 'font-family:\'' . $advantage_box_title_font_family . '\';' : '';
			}
			if ( $advantage_box_title_font_style !== '' ) {
				$title_style .= esc_attr( $advantage_box_title_font_style );
			}

			if ( is_numeric( $advantage_box_title_font_size ) ) {
				$advantage_box_title_font_size = 'desktop: ' . $advantage_box_title_font_size . 'px;';
			}
			if ( is_numeric( $advantage_box_title_font_line_height ) ) {
				$advantage_box_title_font_line_height = 'desktop: ' . $advantage_box_title_font_line_height . 'px;';
			}

			$title_args = array(
				'target'      => '#' . $id . ' .st-advantage-box-title h3',
				'media_sizes' => array(
					'font-size'   => $advantage_box_title_font_size,
					'line-height' => $advantage_box_title_font_line_height,
				),
			);

			$title_responsive = get_ultimate_vc_responsive_media_css( $title_args );
			$title_style      .= $advantage_box_title_font_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $advantage_box_title_font_letter_spacing ) . 'px;' : '';
			$title_style      .= $advantage_box_title_color !== '' ? 'color:' . esc_attr( $advantage_box_title_color ) . ';' : '';
			$title_style      .= '"';

			// Description font style
			$desc_style = 'style="';
			if ( $desc_style !== '' ) {
				$advantage_box_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $advantage_box_desc_font ) : '';
				$desc_style                     .= ! empty( $advantage_box_desc_font_family ) ? 'font-family:\'' . $advantage_box_desc_font_family . '\';' : '';
			}
			if ( $advantage_box_desc_font_style !== '' ) {
				$desc_style .= esc_attr( $advantage_box_desc_font_style );
			}

			if ( is_numeric( $advantage_box_desc_font_size ) ) {
				$advantage_box_desc_font_size = 'desktop: ' . $advantage_box_desc_font_size . 'px;';
			}
			if ( is_numeric( $advantage_box_desc_font_line_height ) ) {
				$advantage_box_desc_font_line_height = 'desktop: ' . $advantage_box_desc_font_line_height . 'px;';
			}

			$desc_args = array(
				'target'      => '#' . $id . ' .st-advantage-box-desc',
				'media_sizes' => array(
					'font-size'   => $advantage_box_title_font_size,
					'line-height' => $advantage_box_title_font_line_height,
				),
			);

			$desc_responsive = get_ultimate_vc_responsive_media_css( $desc_args );
			$desc_style      .= $advantage_box_desc_font_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $advantage_box_desc_font_letter_spacing ) . 'px;' : '';
			$desc_style      .= $advantage_box_desc_font_color !== '' ? 'color:' . esc_attr( $advantage_box_desc_font_color ) . ';' : '';
			$desc_style      .= '"';

			if ( $advantage_box_bg_overlay_color ) {
				$overlay = ' style="background:' . esc_attr( $advantage_box_bg_overlay_color ) . ';"';
			}

			$href = vc_build_link( $link );

			$url         = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
			$target      = ( isset( $href['target'] ) && $href['target'] !== '' ) ? esc_attr( trim( $href['target'] ) ) : '';
			$link_title  = ( isset( $href['title'] ) && $href['title'] !== '' ) ? esc_attr( $href['title'] ) : __( 'Read more', 'adamas-vc-shortcodes' );
			$rel         = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? esc_attr( $href['rel'] ) : '';
			$link_prefix = '<a class="st-advantage-box-link" ' . Ultimate_VC_Addons::uavc_link_init( $url, $target, $link_title, $rel ) . '>';
			$link_sufix  = '</a>';

			$img      = wp_get_attachment_image_src( $atts['advantage_box_bg'], 'full' );
			$img_link = $img[0];

			if ( $img ) {
				$bg_img = ' style="background-image:url(' . esc_url( $img_link ) . ');"';
			} else {
				$bg_img = '';
			}

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-advantage-box ' . esc_attr( $el_class ) . '" id=' . $id . '>';
			$output .= '<div class="st-advantage-box-bg" ' . $bg_img . '></div>';
			$output .= '<div class="st-advantage-box-info ' . esc_attr( $align ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
			$output .= '<div class="st-advantage-box-title"><h3 class="ult-responsive" ' . $title_style . ' ' . $title_responsive . '><i class="st-h-before"><i></i></i>' . esc_attr( $advantage_box_title ) . '</h3></div>';
			$output .= '<div class="st-advantage-box-desc ult-responsive" ' . $desc_style . ' ' . $desc_responsive . '>' . do_shortcode( $content ) . '</div>';
			if ( $url !== '' ) {
				$output .= $link_prefix;
				$output .= '<span class="st-advantage-box-link-text">' . $link_title . '</span>';
				$output .= '<span class="st-advantage-box-link-icon"><i class="fa fa-angle-right" aria-hidden="true"></i></span>';
				$output .= $link_sufix;
			}
			$output .= '</div>'; // st-advantage-box-info
			$output .= '<div class="st-advantage-box-overlay" ' . $overlay . '></div>';
			$output .= '</div>'; // st-advantage-box

			return $output;
		}

		function advantage_box_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Advantage Box', 'adamas-vc-shortcodes' ),
					'base'        => 'st_advantage_box_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/advantage_box.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays advantage box', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Module title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title',
							'description' => '',
							'admin_label' => true,
						),
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_bg',
							'description' => '',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Overlay background color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_bg_overlay_color',
							'description' => __( 'Please, select color for background overlay.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'dropdown',
							'heading'     => __( 'Title alignment', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_align',
							'value'       => array(
								__( 'Left', 'adamas-vc-shortcodes' )    => 'left',
								__( 'Center', 'adamas-vc-shortcodes' )  => 'center',
								__( 'Right', 'adamas-vc-shortcodes' )   => 'right',
								__( 'Justify', 'adamas-vc-shortcodes' ) => 'justify',
							),
							'description' => __( 'Please, select title alignment.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						array(
							'type'       => 'vc_link',
							'heading'    => __( 'Link', 'adamas-vc-shortcodes' ),
							'param_name' => 'link',
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_font_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_title_font_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Desc typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'advantage_box_desc_font_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_advantage_box_module = new St_Advantage_Box_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_advantage_box_module extends WPBakeryShortCode {
		}
	}
}