<?php
/*
 * Add-on Name: Product Carousel Module
 */
if ( ! class_exists( 'St_Product_Carousel_Module' ) ) {
	class St_Product_Carousel_Module {
		function __construct() {
			add_shortcode( 'st_product_carousel_module', array( $this, 'product_carousel_module_shortcode' ) );
			add_action( 'init', array( $this, 'product_carousel_module_init' ) );
		}

		function product_carousel_module_shortcode( $atts ) {
			$product_carousel_data = '';
			$product_img           = $product_title = $product_title_font = $product_title_font_style = $product_title_color = $product_title_font_size = $product_title_line_height = $product_title_letter_spacing = '';
			$product_desc          = $product_desc_font = $product_desc_font_style = $product_desc_color = $product_desc_font_size = $product_desc_line_height = $product_desc_letter_spacing = '';
			$product_link          = $product_link_color = $el_class = $module_animation = $animation = $animated = '';

			extract( shortcode_atts( array(
				'product_carousel_data'        => '',
				'product_img'                  => '',
				'product_title'                => '',
				'product_title_font'           => '',
				'product_title_font_style'     => '',
				'product_title_color'          => '',
				'product_title_font_size'      => '',
				'product_title_line_height'    => '',
				'product_title_letter_spacing' => '',
				'product_desc'                 => '',
				'product_desc_font'            => '',
				'product_desc_font_style'      => '',
				'product_desc_color'           => '',
				'product_desc_font_size'       => '',
				'product_desc_line_height'     => '',
				'product_desc_letter_spacing'  => '',
				'product_link'                 => '',
				'product_link_color'           => '',
				'module_animation'             => '',
				'el_class'                     => '',
			), $atts ) );

			$product_count = 0;
			$output        = '';

			$product_carousel_data = json_decode( urldecode( $product_carousel_data ), true );

			$id = uniqid( 'st-product-carousel-' );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"'; // TODO : Check animation
			}

			// Title
			$product_title_style = 'style="';

			if ( $product_title_font !== '' ) {
				$product_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $product_title_font ) : '';
				$product_title_style       .= ! empty( $product_title_font_family ) ? 'font-family:\'' . $product_title_font_family . '\';' : '';
			}
			if ( $product_title_font_style !== '' ) {
				$product_title_style .= esc_attr( $product_title_font_style );
			}

			if ( is_numeric( $product_title_font_size ) ) {
				$product_title_font_size = 'desktop: ' . $product_title_font_size . 'px;';
			}
			if ( is_numeric( $product_title_line_height ) ) {
				$product_title_line_height = 'desktop: ' . $product_title_line_height . 'px;';
			}

			$product_title_args = array(
				'target'      => '#' . $id . ' .st-product-carousel-title',
				'media_sizes' => array(
					'font-size'   => $product_title_font_size,
					'line-height' => $product_title_line_height,
				),
			);

			$product_title_responsive = get_ultimate_vc_responsive_media_css( $product_title_args );
			$product_title_style      .= $product_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $product_title_letter_spacing ) . 'px;' : '';
			$product_title_style      .= $product_title_color !== '' ? 'color:' . esc_attr( $product_title_color ) . ';' : '';
			$product_title_style      .= '"';

			// Description
			$product_desc_style = 'style="';

			if ( $product_desc_font !== '' ) {
				$product_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $product_desc_font ) : '';
				$product_desc_style       .= ! empty( $product_desc_font_family ) ? 'font-family:\'' . $product_desc_font_family . '\';' : '';
			}
			if ( $product_desc_font_style !== '' ) {
				$product_desc_style .= esc_attr( $product_desc_font_style );
			}

			if ( is_numeric( $product_desc_font_size ) ) {
				$product_desc_font_size = 'desktop: ' . $product_desc_font_size . 'px;';
			}
			if ( is_numeric( $product_desc_line_height ) ) {
				$product_desc_line_height = 'desktop: ' . $product_desc_line_height . 'px;';
			}

			$product_desc_args = array(
				'target'      => '#' . $id . ' .st-product-carousel-desc',
				'media_sizes' => array(
					'font-size'   => $product_desc_font_size,
					'line-height' => $product_desc_line_height,
				),
			);

			$product_desc_responsive = get_ultimate_vc_responsive_media_css( $product_desc_args );
			$product_desc_style      .= $product_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $product_desc_letter_spacing ) . 'px;' : '';
			$product_desc_style      .= $product_desc_color !== '' ? 'color:' . esc_attr( $product_desc_color ) . ';' : '';
			$product_desc_style      .= '"';

			$product_link_style = '';
			if ( $product_link_color ) {
				$product_link_style = 'style="';
				$product_link_style .= $product_link_color !== '' ? 'color:' . esc_attr( $product_link_color ) . ';' : '';
				$product_link_style .= '"';
			}

			$output .= '<div class="st-product-carousel"><div id="' . esc_attr( $id ) . '" class="st-product-carousel-slider ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
			if ( isset( $product_carousel_data ) ) {
				foreach ( $product_carousel_data as $product_carousel_datas ) {
					$output .= '<div class="st-product-carousel-item">';
					if ( isset( $product_carousel_datas['product_img'] ) ) {
						$img      = wp_get_attachment_image_src( $product_carousel_datas['product_img'], 'full' );
						$img_alt  = strip_tags( get_post_meta( $product_carousel_datas['product_img'], '_wp_attachment_image_alt', true ) );
						$img_link = $img[0];
						$output   .= '<div class="st-product-carousel-img"><img src="' . esc_url( $img_link ) . '" alt="' . esc_attr( $img_alt ) . '" /></div>';
					}
					$output .= '<div class="st-product-carousel-info">';
					if ( isset( $product_carousel_datas['product_mark'] ) ) {
						$output .= '<div class="st-product-carousel-mark">' . esc_attr( $product_carousel_datas['product_mark'] ) . '</div>';
					}
					if ( isset( $product_carousel_datas['product_title'] ) ) {
						$output .= '<div class="st-product-carousel-title ult-responsive" ' . $product_title_style . ' ' . $product_title_responsive . '><h3>' . esc_attr( $product_carousel_datas['product_title'] ) . '</h3></div>';
					}
					if ( isset( $product_carousel_datas['product_desc'] ) ) {
						$output .= '<div class="st-product-carousel-desc ult-responsive" ' . $product_desc_style . ' ' . $product_desc_responsive . '>' . wp_kses_post( $product_carousel_datas['product_desc'] ) . '</div>';
					}
					$product_link = $product_carousel_datas['product_link'];
					$link         = vc_build_link( $product_link );
					$link_title   = $link['title'];
					$link_url     = $link['url'];
					$link_target  = $link['target'];

					if ( $link_target ) {
						$target = ' target="' . esc_attr( trim( $link_target ) ) . '"';
					} else {
						$target = '';
					}

					if ( ! empty( $link['rel'] ) ) {
						$rel = ' rel="' . esc_attr( $link['rel'] ) . '"';
					} else {
						$rel = '';
					}

					if ( isset( $product_carousel_datas['product_link'] ) ) {
						$output .= '<a class="st-product-carousel-link" href="' . esc_url( $link_url ) . '" ' . $target . ' title="' . esc_attr( $product_carousel_datas['product_title'] ) . '" ' . $product_link_style . ' ' . $rel . '>' . esc_html__( 'Learn more', 'adamas-vc-shortcodes' ) . '</a>';
					}
					$output .= '</div>'; // st-product-carousel-info
					$output .= '</div>'; // st-product-carousel-item
				}
			}
			$output .= '</div>'; // st-product-carousel-slider
			$output .= '</div>'; // st-product-carousel

			wp_enqueue_script( 'slick' );

			$rtl = '';
			if ( is_rtl() ) {
				$rtl = 'rtl:true';
			}

			$output .= '<script type="text/javascript">';
			$output .= '(function($){';
			$output .= '"use strict";';
			$output .= '$(document).ready(function(){';
			$output .= '$("#' . esc_js( $id ) . '").slick({rows:0,autoplay:true,autoplaySpeed:7000,slidesToShow:1,slidesToScroll:1,swipeToSlide:false,centerMode:true,focusOnSelect:true,responsive:[{breakpoint:767,settings:{centerPadding:"0px"}}],' . $rtl . '});';
			$output .= '})';
			$output .= '})(jQuery);';
			$output .= '</script>';

			return $output;
		}

		function product_carousel_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Product Carousel', 'adamas-vc-shortcodes' ),
					'base'        => 'st_product_carousel_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/product_carousel.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Products in carousel', 'adamas-vc-shortcodes' ), // TODO : Add description
					'params'      => array(
						array(
							'type'        => 'param_group',
							'heading'     => __( 'Carousel settings', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_carousel_data',
							'description' => __( 'Add products here.', 'adamas-vc-shortcodes' ),
							'value'       => urlencode( json_encode( array(
								array(
									'product_mark'  => '',
									'product_title' => '',
									'product_img'   => '',
									'product_desc'  => '',
									'product_link'  => '',
								)
							) ) ),
							'params'      => array(
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Product title', 'adamas-vc-shortcodes' ),
									'param_name'  => 'product_title',
									'description' => '',
									'admin_label' => true
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Product mark', 'adamas-vc-shortcodes' ),
									'param_name'  => 'product_mark',
									'description' => '',
								),
								array(
									'type'       => 'attach_image',
									'heading'    => __( 'Product Image', 'adamas-vc-shortcodes' ),
									'param_name' => 'product_img',
								),
								array(
									'type'        => 'textarea',
									'heading'     => __( 'Product description', 'adamas-vc-shortcodes' ),
									'param_name'  => 'product_desc',
									'value'       => '',
									'description' => '',
								),
								array(
									'type'        => 'vc_link',
									'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
									'param_name'  => 'product_link',
									'value'       => '',
									'description' => '',
								),
							),
						),
						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),
						// Link Color
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Link font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'product_link_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_product_carousel_module = new St_Product_Carousel_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_product_carousel_module extends WPBakeryShortCode {
		}
	}
}