<?php

$el_class = $brochure_width = $width = $module_animation = $animation = $animated = '';
$output   = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'module_animation'           => '',
	'brochure_title'             => '',
	'brochure_link'              => '',
	'brochure_width'             => '',
	'brochure_title_color'       => '',
	'brochure_title_color_hover' => '',
	'brochure_bg_color'          => '',
	'brochure_bg_color_hover'    => '',
	'brochure_hide_size'         => '',
	'brochure_hide_extension'    => '',
	'target_blank'               => '',
	'el_class'                   => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

// File
$file_url = esc_url( $brochure_link );
if ( $target_blank ) {
	$link_start = '<a href="' . esc_url( $file_url ) . '" target="_blank">';
} else {
	$link_start = '<a href="' . esc_url( $file_url ) . '">';
}
$link_end   = '</a>';
$path_parts = pathinfo( $file_url );
$file_get   = wp_remote_get( $file_url );
$size       = wp_remote_retrieve_header( $file_get, 'Content-Length' );

$file_size = $size;
switch ( $size ) {
	case $size < 1024:
		$file_size = $size . ' B';
		break;
	case $size < 1048576:
		$file_size = round( $size / 1024, 2 ) . ' KB';
		break;
	case $size < 1073741824:
		$file_size = round( $size / 1048576, 2 ) . ' MB';
		break;
	case $size < 1099511627776:
		$file_size = round( $size / 1073741824, 2 ) . ' GB';
		break;
}

$file_extension = $path_parts['extension'];

$style = '';
if ( $brochure_title_color != '' || $brochure_bg_color != '' ) {
	$style .= 'style="';
	if ( $brochure_title_color != '' ) {
		$style .= 'color:' . esc_attr( $brochure_title_color ) . ';';
	}
	if ( $brochure_bg_color != '' ) {
		$style .= 'background:' . esc_attr( $brochure_bg_color ) . ';';
	}
	$style .= '"';
}

if ( $brochure_width != '' ) {
	$width .= 'style="width:' . $brochure_width . ';"';
}

$hover_style = '';

if ( $brochure_title_color_hover != '' || $brochure_bg_color_hover != '' ) {
	$hover_style .= '<style type="text/css">';
	if ( $brochure_title_color_hover != '' ) {
		$hover_style .= '.st-brochure:hover .st-brochure-inner:before{color:' . esc_attr( $brochure_title_color_hover ) . ' !important} ';
	}
	if ( $brochure_bg_color_hover != '' ) {
		$hover_style .= '.st-brochure:hover{background:' . esc_attr( $brochure_bg_color_hover ) . ' !important} ';
	}
	$hover_style .= '</style>';
}

if ( $brochure_hide_size ) {
	$file_size_output = '';
} else {
	$file_size_output = esc_attr( $file_size );
}

if ( $brochure_hide_extension ) {
	$extension_output = '';
} else {
	$extension_output = strtoupper( esc_attr( $file_extension ) );
}


$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-brochure ' . esc_attr( $css_class ) . '" ' . $width . '>';
if ( is_rtl() ) {
	$output .= $link_start . '<div class="st-brochure-inner ' . esc_attr( $file_extension ) . '" ' . $style . '>' . esc_attr( $brochure_title ) . ' ' . $extension_output . ' ' . $file_size_output . '</div>' . $link_end;
} else {
	$output .= $link_start . '<div class="st-brochure-inner ' . esc_attr( $file_extension ) . '" ' . $style . '>' . esc_attr( $brochure_title );
	if ( $extension_output !== '' || $file_size_output !== '' ) {
		$output .= ' (';
		if ( $extension_output !== '' ) {
			$output .= $extension_output;
		}
		if ( $extension_output !== '' && $file_size_output !== '' ) {
			$output .= ', ';
		}
		if ( $file_size_output !== '' ) {
			$output .= $file_size_output;
		}
		$output .= ')';
	}
	$output .= '</div>' . $link_end;
}
$output .= '</div>'; // st-brochure

if ( $hover_style != '' ) {
	$output .= "<script type=\"text/javascript\">jQuery(document).ready(function(){jQuery('head').append('" . $hover_style . "');});</script>";
}

echo $output;