<?php

$el_class = $history_layout = $history_year = $year_color = $history_title = $history_img = $history_link = $year_bg_color = $module_animation = $animation = $animated = $year_style = $css_style = '';
$output   = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'module_animation' => '',
	'history_layout'   => '',
	'year_color'       => '',
	'year_bg_color'    => '',
	'history_year'     => '',
	'history_title'    => '',
	'history_img'      => '',
	'history_link'     => '',
	'el_class'         => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

if ( empty( $history_layout ) ) {
	$history_layout = 'history-year-title';
}

$css_classes = array(
	$el_class,
	$history_layout,
);

$history_title = $atts['history_title'];
$history_img   = wp_get_attachment_image_src( $atts['history_img'], 'full' );
$img_link      = $history_img[0];

if ( ! empty( $history_link ) ) {
	$history_link = vc_build_link( $history_link );
	$link         = '<a class="st-history-item-link" href="' . esc_url( $history_link['url'] ) . '" ' . ( $history_link['target'] ? ' target="' . esc_attr( trim( $history_link['target'] ) ) . '"' : '' ) . ' title="' . esc_attr( $history_link['title'] ) . '" ' . ( $history_link['rel'] ? ' rel="' . esc_attr( $history_link['rel'] ) . '"' : '' ) . '>' . esc_attr( $history_link['title'] ) . '</a>';
} else {
	$link = '';
}

if ( $history_img ) {
	$css_style = 'background-image: url(' . esc_url( $img_link ) . ');';
}

if ( $year_bg_color ) {
	$bg_color = 'style="background-color:' . esc_attr( $year_bg_color ) . '"';
}

if ( $year_color ) {
	$year_style = ' style="color:' . esc_attr( $year_color ) . '"';
}

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-history-item ' . esc_attr( $css_class ) . '">';
$output .= '<div class="st-history-item-year" ' . $bg_color . '><span ' . $year_style . '>' . esc_attr( $history_year ) . '</span></div>';
$output .= '<div class="st-history-item-image" style="' . esc_attr( $css_style ) . '"></div>';
$output .= '<div class="st-history-item-inner ' . $animated . '" ' . $animation . '>';
$output .= '<div class="st-history-item-title-wrapper"><h3 class="st-history-grid-title">' . esc_attr( $history_title ) . '</h3></div>';
$output .= '<div class="st-history-item-desc">' . wpb_js_remove_wpautop( $content, true ) . '</div>';
$output .= $link;
$output .= '</div>'; // st-history-item-inner
$output .= '</div>'; // st-history-item

echo $output;