<?php

$title = $el_class = $value = $units = $pie_bar_width = $label_value = $css = $css_animation = '';
$atts  = $this->convertOldColorsToNew( $atts );
$atts  = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'title'                => '',
	'value'                => '',
	'label_value'          => '',
	'units'                => '',
	'el_class'             => '',
	'pie_bar_width'        => '',
	'pie_bar_bg_color'     => '',
	'pie_bar_value_color'  => '',
	'pie_chart_bg_color'   => '',
	'value_font'           => '',
	'value_font_style'     => '',
	'value_color'          => '',
	'value_font_size'      => '',
	'value_letter_spacing' => '',
	'module_animation'     => '',
	'css'                  => '',
), $atts ) );

wp_enqueue_script( 'progress-circle', get_template_directory_uri() . '/assets/js/ProgressCircle.min.js', array( 'jquery' ), false, true );
wp_enqueue_script( 'st-adamas-pie', get_template_directory_uri() . '/assets/js/jquery.chart.min.js', array( 'jquery' ), false, true );

if ( $pie_bar_width == '' ) {
	$pie_bar_width = '10';
}

$id = uniqid( 'st-pie-chart-' );

// Value style
$value_style = 'style="';

if ( $value_font !== '' ) {
	$value_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $client_name_font ) : '';
	if ( $value_font_family !== '' ) {
		$value_style .= 'font-family:\'' . $value_font_family . '\';';
	}
}

if ( $value_font_style !== '' ) {
	$value_style .= esc_attr( $value_font_style );
}

if ( is_numeric( $value_font_size ) ) {
	$value_font_size = 'desktop:' . $value_font_size . 'px;';
}

$value_args = array(
	'target'      => "#" . $id . " .vc_pie_chart_value",
	'media_sizes' => array(
		'font-size' => $value_font_size,
	),
);

$value_responsive = get_ultimate_vc_responsive_media_css( $value_args );

$value_style .= $value_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $value_letter_spacing ) . 'px;' : '';
$value_style .= $value_color !== '' ? 'color:' . esc_attr( $value_color ) . ';' : '';
$value_style .= '"';

$class_to_filter = 'vc_pie_chart wpb_content_element';
$class_to_filter .= vc_shortcode_custom_css_class( $css, ' ' ) . $this->getExtraClass( $el_class ) . $this->getCSSAnimation( $css_animation );
$css_class       = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $class_to_filter, $this->settings['base'], $atts );

$output = '<div class= "' . esc_attr( $css_class ) . '" data-pie-value="' . esc_attr( $value ) . '" data-pie-label-value="' . esc_attr( $label_value ) . '" data-pie-units="' . esc_attr( $units ) . '" data-pie-color="' . esc_attr( $pie_bar_value_color ) . '" data-pie-border-width="' . esc_attr( $pie_bar_width ) . '">';
$output .= '<div class="wpb_wrapper">';
$output .= '<div class="vc_pie_wrapper" id="' . esc_attr( $id ) . '">';
$output .= '<span class="vc_pie_chart_back" style="border-color: ' . esc_attr( $pie_bar_bg_color ) . '; background-color: ' . esc_attr( $pie_chart_bg_color ) . '"></span>';
$output .= '<span class="vc_pie_chart_value ult-responsive" ' . $value_style . ' ' . $value_responsive . '></span>';
$output .= '<canvas width="101" height="101"></canvas>';
$output .= '</div>';

if ( '' !== $title ) {
	$output .= '<h4 class="wpb_heading wpb_pie_chart_heading">' . $title . '</h4>';
}

$output .= '</div>';
$output .= '</div>';

echo $output;