<?php
/*
* Add-on Name: ST Info Boxes
*/
if ( ! class_exists( 'St_Info_Boxes' ) ) {
	class St_Info_Boxes {
		function __construct() {
			// Add shortcode for icon box
			add_shortcode( "st_info_boxes", array( &$this, 'st_info_boxes' ) );
			add_shortcode( 'st_info_box', array( &$this, 'st_info_box' ) );
			// Initialize the icon box component for Visual Composer
			add_action( 'init', array( &$this, 'st_info_box_init' ) );

			add_action( 'wp_enqueue_scripts', array( $this, 'icon_box_scripts' ), 1 );
		}

		function st_info_boxes( $atts, $content = null ) {
			$el_class = $output = '';

			extract( shortcode_atts( array(
				'el_class' => '',
			), $atts ) );

			$output .= '<div class="st-info-boxes ' . $el_class . '">';
			$output .= '	<div class="st-info-boxes-inner">';
			$output .= do_shortcode( $content );
			$output .= '	</div>';
			$output .= '</div>';

			return $output;
		}

		// Add shortcode for icon-box
		function st_info_box( $atts, $content = null ) {
			$icon_type  = $icon_img = $img_width = $icon = $icon_color = $icon_color_bg = $icon_size = $icon_style = $icon_border_style = $icon_border_radius = $icon_color_border = $icon_border_size = $icon_border_spacing = $el_class = $icon_animation = $title = $link = $hover_effect = $pos = $read_more = $read_text = $box_border_style = $box_border_width = $box_border_color = $box_bg_color = $pos = $css_class = $desc_font_line_height = $title_font_line_height = $info_box_shadow = '';
			$title_font = $title_font_style = $title_font_size = $title_font_color = $title_font_color_hover = $desc_font = $desc_font_style = $desc_font_size = $desc_font_color = $st_desc_font = $st_desc_font_style = $st_desc_font_size = $st_desc_font_color = $box_min_height = $icon_color_hover = $icon_color_bg_hover = $icon_color_border_hover = $style = $module_animation = $animation = $animated = $elem = $short_desc = '';
			extract( shortcode_atts( array(
				'icon_type'                => 'selector',
				'icon'                     => 'none',
				'icon_img'                 => '',
				'img_width'                => '48',
				'icon_size'                => '32',
				'icon_color'               => '#333',
				'icon_style'               => 'none',
				'icon_color_bg'            => '#ffffff',
				'icon_color_border'        => '#333333',
				'icon_border_style'        => '',
				'icon_border_size'         => '1',
				'icon_border_radius'       => '500',
				'icon_border_spacing'      => '50',
				'icon_animation'           => '',
				'title'                    => '',
				'link'                     => '',
				'hover_effect'             => 'style_1',
				'icon_color_hover'         => '',
				'icon_color_bg_hover'      => '',
				'icon_color_border_hover'  => '',
				'pos'                      => 'default',
				'box_min_height'           => '',
				'box_border_style'         => '',
				'box_border_width'         => '',
				'box_border_color'         => '',
				'box_bg_color'             => '',
				'info_box_shadow'          => '',
				'read_more'                => 'none',
				'read_text'                => 'Read More',
				'title_font'               => '',
				'title_font_style'         => '',
				'title_font_size'          => '',
				'title_font_line_height'   => '',
				'title_font_color'         => '',
				'title_font_color_hover'   => '',
				'desc_font'                => '',
				'desc_font_style'          => '',
				'desc_font_size'           => '',
				'desc_font_color'          => '',
				'desc_font_line_height'    => '',
				'st_desc_font'             => '',
				'st_desc_font_style'       => '',
				'st_desc_font_size'        => '',
				'st_desc_font_color'       => '',
				'st_desc_font_line_height' => '',
				'module_animation'         => '',
				'short_desc'               => '',
				'title_elem'               => '',
				'title_elem_bg_check'      => '',
				'el_class'                 => '',
				'css_info_box'             => '',
			), $atts, 'bsf-info-box' ) );
			$html             = $target = $suffix = $prefix = $title_style = $desc_style = $inf_design_style = $st_desc_style = '';
			$inf_design_style = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css_info_box, ' ' ), "bsf-info-box", $atts );
			$inf_design_style = esc_attr( $inf_design_style );

			if ( $info_box_shadow ) {
				$el_class .= ' with-shadow';
			}

			$box_icon = do_shortcode( '[just_icon icon_type="' . $icon_type . '" icon="' . $icon . '" icon_img="' . $icon_img . '" img_width="' . $img_width . '" icon_size="' . $icon_size . '" icon_color="' . $icon_color . '" icon_style="' . $icon_style . '" icon_color_bg="' . $icon_color_bg . '" icon_color_border="' . $icon_color_border . '"  icon_border_style="' . $icon_border_style . '" icon_border_size="' . $icon_border_size . '" icon_border_radius="' . $icon_border_radius . '" icon_border_spacing="' . $icon_border_spacing . '" icon_animation="' . $icon_animation . '"]' );
			$prefix   .= '<div class="aio-icon-component ' . $inf_design_style . ' ' . $css_class . ' ' . $el_class . ' ' . $hover_effect . '">';
			$suffix   .= '</div> <!-- aio-icon-component -->';
			$ex_class = $ic_class = '';
			if ( $pos != '' ) {
				$ex_class .= $pos . '-icon';
				$ic_class = 'aio-icon-' . $pos;
			}

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . $module_animation . '"';
			}

			// Title element
			if ( $title_elem ) {
				if ( $title_elem_bg_check ) {
					$elem .= '<i class="st-infobox-title-before dark-bg"><i></i><i></i></i>';
				} else {
					$elem .= '<i class="st-infobox-title-before"><i></i><i></i></i>';
				}
			}

			/* title */
			if ( $title_font != '' ) {
				$font_family = get_ultimate_font_family( $title_font );
				if ( $font_family != '' ) {
					$title_style .= ! empty( $font_family ) ? 'font-family:\'' . $font_family . '\';' : '';
				}
			}
			if ( $title_font_style != '' ) {
				$title_style .= get_ultimate_font_style( $title_font_style );
			}

			if ( is_numeric( $title_font_size ) ) {
				$title_font_size = 'desktop:' . $title_font_size . 'px;';
			}
			if ( is_numeric( $title_font_line_height ) ) {
				$title_font_line_height = 'desktop:' . $title_font_line_height . 'px;';
			}
			$info_box_id        = 'Info-box-wrap-' . rand( 1000, 9999 );
			$info_box_args      = array(
				'target'      => '#' . $info_box_id . ' .aio-icon-title', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $title_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $title_font_line_height
				),
			);
			$info_box_data_list = get_ultimate_vc_responsive_media_css( $info_box_args );

			if ( $title_font_color != '' ) {
				$title_style .= 'color:' . $title_font_color . ';';
			}

			/* Short description */
			if ( $desc_font != '' ) {
				$desc_font_family = get_ultimate_font_family( $desc_font );
				if ( $font_family !== '' ) {
					$desc_style .= ! empty( $desc_font_family ) ? 'font-family:\'' . $desc_font_family . '\';' : '';
				}
			}
			if ( $desc_font_style != '' ) {
				$desc_style .= get_ultimate_font_style( $desc_font_style );
			}

			if ( is_numeric( $desc_font_size ) ) {
				$desc_font_size = 'desktop:' . $desc_font_size . 'px;';
			}
			if ( is_numeric( $desc_font_line_height ) ) {
				$desc_font_line_height = 'desktop:' . $desc_font_line_height . 'px;';
			}

			$info_box_desc_args      = array(
				'target'      => '#' . $info_box_id . ' .aio-icon-description', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $desc_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $desc_font_line_height
				),
			);
			$info_box_desc_data_list = get_ultimate_vc_responsive_media_css( $info_box_desc_args );
			if ( $desc_font_color != '' ) {
				$desc_style .= 'color:' . $desc_font_color . ';';
			}

			/* Description */
			if ( $st_desc_font != '' ) {
				$st_font_family = get_ultimate_font_family( $st_desc_font );
				if ( $st_font_family !== '' ) {
					$st_desc_style .= ! empty( $st_font_family ) ? 'font-family:\'' . $st_font_family . '\';' : '';
				}
			}
			if ( $st_desc_font_style != '' ) {
				$st_desc_style .= get_ultimate_font_style( $st_desc_font_style );
			}

			if ( is_numeric( $st_desc_font_size ) ) {
				$st_desc_font_size = 'desktop:' . $st_desc_font_size . 'px;';
			}
			if ( is_numeric( $st_desc_font_line_height ) ) {
				$st_desc_font_line_height = 'desktop:' . $st_desc_font_line_height . 'px;';
			}

			$info_box_st_desc_args      = array(
				'target'      => '#' . $info_box_id . ' .st-info-box-description', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $st_desc_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $st_desc_font_line_height
				),
			);
			$info_box_st_desc_data_list = get_ultimate_vc_responsive_media_css( $info_box_st_desc_args );
			if ( $st_desc_font_color != '' ) {
				$st_desc_style .= 'color:' . $st_desc_font_color . ';';
			}

			$box_style = $box_style_data = '';
			if ( $pos == 'square_box' || $pos == 'square_box_2' ) {
				if ( $box_min_height != '' ) {
					$box_style_data .= "data-min-height='" . $box_min_height . "px'";
				}
				if ( $box_border_color != '' ) {
					$box_style .= "border-color:" . $box_border_color . ";";
				}
				if ( $box_border_style != '' ) {
					$box_style .= "border-style:" . $box_border_style . ";";
				}
				if ( $box_border_width != '' ) {
					$box_style .= "border-width:" . $box_border_width . "px;";
				}
				if ( $box_bg_color != '' ) {
					$box_style .= "background-color:" . $box_bg_color . ";";
				}
			}
			$html .= '<div id="' . $info_box_id . '" class="aio-icon-box ' . $ex_class . ' ' . $animated . '" style="' . $box_style . '" ' . $box_style_data . ' ' . $animation . '>';
			$html .= '<div class="aio-icon-box-inner">';

			if ( $pos == "heading-right" || $pos == "right" || $pos == "right-title" ) {

				if ( $pos == "right" ) {
					$html .= '<div class="aio-ibd-block" >';
				}
				if ( $title !== '' ) {
					$html .= '<div class="aio-icon-header" >';
					$html .= '<h3 class="aio-icon-title ult-responsive" ' . $info_box_data_list . ' style="' . $title_style . '">' . $elem . $title . '</h3>';
					$html .= '</div> <!-- header -->';
				}
				if ( $pos !== "right" ) {
					if ( $icon !== 'none' || $icon_img !== '' ) {
						$html .= '<div class="' . $ic_class . '" >' . $box_icon . '</div>';
					}
				}
				if ( $short_desc !== '' ) {
					$html .= '<div class="aio-icon-description ult-responsive" ' . $info_box_desc_data_list . ' style="' . $desc_style . '">';
					$html .= wp_kses_post( $short_desc );
					$html .= '</div> <!-- description -->';
				}
				if ( $pos == "right" ) {
					$html .= '</div> <!-- aio-ibd-block -->';
					if ( $icon !== 'none' || $icon_img !== '' ) {
						$html .= '<div class="' . $ic_class . '">' . $box_icon . '</div>';
					}
				}

			} else {
				if ( $icon !== 'none' || $icon_img != '' ) {
					$html .= '<div class="' . $ic_class . '">' . $box_icon . '</div>';
				}
				if ( $pos == "left" ) {
					$html .= '<div class="aio-ibd-block">';
				}
				if ( $title !== '' ) {
					$html .= '<div class="aio-icon-header" >';
					$html .= '<h3 class="aio-icon-title ult-responsive" ' . $info_box_data_list . ' style="' . $title_style . '">' . $elem . $title . '</h3>';
					$html .= '</div> <!-- header -->';
				}
				if ( $short_desc !== '' ) {
					$html .= '<div class="aio-icon-description ult-responsive" ' . $info_box_desc_data_list . ' style="' . $desc_style . '">';
					$html .= wp_kses_post( $short_desc );
					$html .= '</div> <!-- description -->';
				}
				if ( $pos == "left" ) {
					$html .= '</div> <!-- aio-ibd-block -->';
				}

			}
			$html .= '</div>';
			if ( $content !== '' ) {
				$html .= '<div class="st-info-box-description ult-responsive" ' . $info_box_st_desc_data_list . ' style="' . $st_desc_style . '">';
				$html .= do_shortcode( $content );
				$html .= '</div>';
			}

			$html .= '</div> <!-- aio-icon-box -->';

			$output    = $prefix . $html . $suffix;
			$is_preset = false; //Display settings for Preset
			if ( isset( $_GET['preset'] ) ) {
				$is_preset = true;
			}
			if ( $is_preset ) {
				$text = 'array ( ';
				foreach ( $atts as $key => $att ) {
					$text .= '<br/>	\'' . $key . '\' => \'' . $att . '\',';
				}
				if ( $short_desc != '' ) {
					$text .= '<br/>	\'content\' => \'' . $short_desc . '\',';
				}
				$text   .= '<br/>)';
				$output .= '<pre>';
				$output .= $text;
				$output .= '</pre>';
			}

			return $output;
		}

		/* Add icon box Component*/
		function st_info_box_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map(
					array(
						'name'            => __( 'Info Boxes', 'adamas-vc-shortcodes' ),
						'base'            => 'st_info_boxes',
						'icon'            => get_template_directory_uri() . '/assets/images/shortcode_icons/info_boxes.png',
						'category'        => __( 'ST Addons', 'adamas-vc-shortcodes' ),
						"as_parent"       => array( 'only' => 'st_info_box' ),
						"content_element" => true,
						'params'          => array(
							array(
								"type"        => "textfield",
								"heading"     => __( "Extra class name", "adamas-vc-shortcodes" ),
								"param_name"  => "el_class",
								"description" => __( "If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "adamas-vc-shortcodes" )
							)
						),
						"js_view"         => 'VcColumnView'
					) );

				vc_map(
					array(
						"name"                    => __( "Info Box", "adamas-vc-shortcodes" ),
						"base"                    => "st_info_box",
						"icon"                    => "vc_info_box",
						"class"                   => "info_box",
						"content_element"         => true,
						"description"             => __( "Adds icon box with custom font icon", "adamas-vc-shortcodes" ),
						"controls"                => "full",
						"as_child"                => array( 'only' => 'st_info_boxes' ), // Use only|except attributes to limit parent (separate multiple values with comma)
						"is_container"            => false,
						"show_settings_on_create" => true,
						"params"                  => array(
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon to display:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_type",
								"value"       => array(
									__( "Font Icon Manager", "adamas-vc-shortcodes" ) => "selector",
									__( "Custom Image Icon", "adamas-vc-shortcodes" ) => "custom",
								),
								"description" => __( "Use an existing font icon or upload a custom image.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "icon_manager",
								"class"       => "",
								"heading"     => __( "Select Icon ", "adamas-vc-shortcodes" ),
								"param_name"  => "icon",
								"value"       => "",
								"description" => __( "Click and select icon of your choice. If you can't find the one that suits for your purpose", "adamas-vc-shortcodes" ) . ", " . __( "you can", "adamas-vc-shortcodes" ) . " <a href='admin.php?page=bsf-font-icon-manager' target='_blank'>" . __( "add new here", "adamas-vc-shortcodes" ) . "</a>.",
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "ult_img_single",
								"class"       => "",
								"heading"     => __( "Upload Image Icon:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_img",
								"value"       => "",
								"description" => __( "Upload the custom image icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Image Width", "adamas-vc-shortcodes" ),
								"param_name"  => "img_width",
								"value"       => 48,
								"min"         => 16,
								"max"         => 512,
								"suffix"      => "px",
								"description" => __( "Provide image width", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Size of Icon", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_size",
								"value"       => 32,
								"min"         => 12,
								"max"         => 72,
								"suffix"      => "px",
								"description" => __( "How big would you like it?", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color",
								"value"       => "#333333",
								"description" => __( "Give it a nice paint!", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_style",
								"value"       => array(
									__( "Simple", "adamas-vc-shortcodes" )            => "none",
									__( "Circle Background", "adamas-vc-shortcodes" ) => "circle",
									__( "Square Background", "adamas-vc-shortcodes" ) => "square",
									__( "Design your own", "adamas-vc-shortcodes" )   => "advanced",
								),
								"description" => __( "We have given three quick preset if you are in a hurry. Otherwise, create your own with various options.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Background Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_bg",
								"value"       => "#ffffff",
								"description" => __( "Select background color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "circle", "square", "advanced" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Border Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_style",
								"value"       => array(
									__( "None", "adamas-vc-shortcodes" )   => "",
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								"description" => __( "Select the border style for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Border Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_border",
								"value"       => "#333333",
								"description" => __( "Select border color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Width", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_size",
								"value"       => 1,
								"min"         => 1,
								"max"         => 10,
								"suffix"      => "px",
								"description" => __( "Thickness of the border.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Radius", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_radius",
								"value"       => 500,
								"min"         => 1,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "0 pixel value will create a square border. As you increase the value, the shape convert in circle slowly. (e.g 500 pixels).", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Background Size", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_spacing",
								"value"       => 50,
								"min"         => 30,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "Spacing from center of the icon till the boundary of border / background", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							// Icon Box Heading
							array(
								"type"        => "textfield",
								"class"       => "",
								"heading"     => __( "Title", "adamas-vc-shortcodes" ),
								"param_name"  => "title",
								"admin_label" => true,
								"value"       => "",
								"description" => __( "Provide the title for this icon box.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"        => "checkbox",
								"class"       => "",
								"heading"     => __( "Enable title before/after element", "adamas-vc-shortcodes" ),
								"param_name"  => "title_elem",
								'value'       => array( __( 'Yes', 'adamas-vc-shortcodes' ) => 'yes' ),
								"description" => __( "Check this if you want to enable elements before or after title.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"        => "checkbox",
								"class"       => "",
								"heading"     => __( "Background check for title before/after element", "adamas-vc-shortcodes" ),
								"param_name"  => "title_elem_bg_check",
								'value'       => array( __( 'Yes', 'adamas-vc-shortcodes' ) => 'yes' ),
								"description" => __( "Check this if title is placed on dark background.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "title_elem", "value" => array( "yes" ) ),
							),
							array(
								'type'        => 'textarea',
								'class'       => '',
								'heading'     => __( 'Short description', 'adamas-vc-shortcodes' ),
								'param_name'  => 'short_desc',
								'value'       => '',
								'description' => __( 'Provide short description for this icon box.', 'adamas-vc-shortcodes' ),
							),
							// Add some description
							array(
								"type"             => "textarea_html",
								"class"            => "",
								"heading"          => __( "Description", "adamas-vc-shortcodes" ),
								"param_name"       => "content",
								"value"            => "",
								"description"      => __( "Provide the description for this icon box.", "adamas-vc-shortcodes" ),
								"edit_field_class" => "ult_hide_editor_fullscreen vc_col-xs-12 vc_column wpb_el_type_textarea_html vc_wrapper-param-type-textarea_html vc_shortcode-param",
							),
							// Position the icon box
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Box Style", "adamas-vc-shortcodes" ),
								"param_name"  => "pos",
								"value"       => array(
									__( "Icon at Left with heading", "adamas-vc-shortcodes" )  => "default",
									__( "Icon at Right with heading", "adamas-vc-shortcodes" ) => "heading-right",
									__( "Icon at Left", "adamas-vc-shortcodes" )               => "left",
									__( "Icon at Right", "adamas-vc-shortcodes" )              => "right",
									__( "Icon at Top", "adamas-vc-shortcodes" )                => "top",
									__( "Icon at Left aligned with title", "vc" )     => "left-title",
									__( "Icon at Right aligned with title", "vc" )    => "right-title",
									__( "Boxed Style", "adamas-vc-shortcodes" )                => "square_box",
									__( "Boxed Style 2", "adamas-vc-shortcodes" )              => "square_box_2",
								),
								"description" => __( "Select icon position. Icon box style will be changed according to the icon position.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Box Min Height", "adamas-vc-shortcodes" ),
								"param_name"  => "box_min_height",
								"value"       => "",
								"suffix"      => "px",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Min Height for Box.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Box Border Style", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_style",
								"value"       => array(
									__( "None", "adamas-vc-shortcodes" )   => "",
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Border Style for box border.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "checkbox",
								"class"       => "",
								"heading"     => __( "Enable Box Shadow", "adamas-vc-shortcodes" ),
								"param_name"  => "info_box_shadow",
								"description" => __( "Check this if you want to set shadow for info box.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box_2" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Box Border Width", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_width",
								"value"       => "",
								"suffix"      => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Width for Box Border.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Box Border Color", "adamas-vc-shortcodes" ),
								"param_name"  => "box_border_color",
								"value"       => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Border color for border box.", "adamas-vc-shortcodes" )
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Box Background Color", "adamas-vc-shortcodes" ),
								"param_name"  => "box_bg_color",
								"value"       => "",
								"dependency"  => Array( "element" => "pos", "value" => array( "square_box", "square_box_2" ) ),
								"description" => __( "Select Box background color.", "adamas-vc-shortcodes" )
							),
							// Animation
							array(
								'type'        => 'dropdown',
								'class'       => '',
								'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
								'param_name'  => 'module_animation',
								'value'       => st_adamas_animations_list(),
								'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
							),
							// Customize everything
							array(
								"type"        => "textfield",
								"class"       => "",
								"heading"     => __( "Extra Class", "adamas-vc-shortcodes" ),
								"param_name"  => "el_class",
								"value"       => "",
								"description" => __( "Add extra class name that will be applied to the icon box, and you can use this class for your customizations.", "adamas-vc-shortcodes" ),
							),
							array(
								"type"             => "ult_param_heading",
								"param_name"       => "title_text_typography",
								"heading"          => __( "Title settings", "adamas-vc-shortcodes" ),
								"value"            => "",
								"group"            => "Typography",
								'edit_field_class' => 'ult-param-heading-wrapper no-top-margin vc_column vc_col-sm-12',
							),
							array(
								"type"       => "ultimate_google_fonts",
								"heading"    => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name" => "title_font",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "title_font_style",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "title_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "title_font_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "title_font_color",
								"heading"    => __( "Color", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"             => "ult_param_heading",
								"param_name"       => "desc_text_typography",
								"heading"          => __( "Short description settings", "adamas-vc-shortcodes" ),
								"value"            => "",
								"group"            => "Typography",
								'edit_field_class' => 'ult-param-heading-wrapper vc_column vc_col-sm-12',
							),
							array(
								"type"       => "ultimate_google_fonts",
								"heading"    => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name" => "desc_font",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "desc_font_style",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "desc_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "desc_font_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "desc_font_color",
								"heading"    => __( "Color", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"             => "ult_param_heading",
								"param_name"       => "st_desc_text_typography",
								"heading"          => __( "Description settings", "adamas-vc-shortcodes" ),
								"value"            => "",
								"group"            => "Typography",
								'edit_field_class' => 'ult-param-heading-wrapper vc_column vc_col-sm-12',
							),
							array(
								"type"       => "ultimate_google_fonts",
								"heading"    => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name" => "st_desc_font",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "st_desc_font_style",
								"value"      => "",
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "st_desc_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "st_desc_font_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography",
							),
							array(
								"type"       => "colorpicker",
								"param_name" => "st_desc_font_color",
								"heading"    => __( "Color", "adamas-vc-shortcodes" ),
								"group"      => "Typography"
							),
							array(
								"type"             => "ult_param_heading",
								"text"             => "<span style='display: block;'><a href='http://bsf.io/kqzzi' target='_blank'>" . __( "Watch Video Tutorial", "adamas-vc-shortcodes" ) . " &nbsp; <span class='dashicons dashicons-video-alt3' style='font-size:30px;vertical-align: middle;color: #e52d27;'></span></a></span>",
								"param_name"       => "notification",
								'edit_field_class' => 'ult-param-important-wrapper ult-dashicon ult-align-right ult-bold-font ult-blue-font vc_column vc_col-sm-12',
							),
							array(
								'type'             => 'css_editor',
								'heading'          => __( 'Css', 'adamas-vc-shortcodes' ),
								'param_name'       => 'css_info_box',
								'group'            => __( 'Design ', 'adamas-vc-shortcodes' ),
								'edit_field_class' => 'vc_col-sm-12 vc_column no-vc-background no-vc-border creative_link_css_editor',
							),
						) // end params array
					) // end vc_map array
				); // end vc_map
			} // end function check 'vc_map'
		}// end function icon_box_init

		function icon_box_scripts() {
			$bsf_dev_mode = bsf_get_option( 'dev_mode' );
			if ( $bsf_dev_mode === 'enable' ) {
				$js_path  = '../assets/js/';
				$css_path = '../assets/css/';
				$ext      = '';
			} else {
				$js_path  = '../assets/min-js/';
				$css_path = '../assets/min-css/';
				$ext      = '.min';
			}
			wp_register_script( 'info_box_js', plugins_url( $js_path . 'info-box' . $ext . '.js', __FILE__ ), array( 'jquery' ), ULTIMATE_VERSION, true );
			wp_register_style( 'info-box-style', plugins_url( $css_path . 'info-box' . $ext . '.css', __FILE__ ), array(), ULTIMATE_VERSION, false );
		}
	}//Class end
}

new St_Info_Boxes;

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_St_Info_Boxes extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_St_Info_Box extends WPBakeryShortCode {
	}
}
