<?php
/*
* Add-on Name: Simple Page Block Module
*/
if ( ! class_exists( 'St_Simple_Page_Block_Module' ) ) {
	class St_Simple_Page_Block_Module {
		function __construct() {
			add_shortcode( 'st_simple_page_block_module', array( $this, 'simple_page_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'simple_page_block_module_init' ) );
		}

		function simple_page_block_module_shortcode( $atts, $content ) {
			$output = $simple_page_block_img = $simple_page_block_title = $simple_page_block_link = $simple_page_block_title_font = $simple_page_block_title_font_style = $simple_page_block_title_color = $simple_page_block_title_font_size = $simple_page_block_title_line_height = $simple_page_block_title_letter_spacing = $simple_page_block_desc_font = $simple_page_block_desc_font_style = $simple_page_block_desc_color = $simple_page_block_desc_font_size = $simple_page_block_desc_line_height = $simple_page_block_desc_letter_spacing = $bg_style = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'simple_page_block_img'                  => '',
				'simple_page_block_title'                => '',
				'simple_page_block_link'                 => '',
				'simple_page_block_title_font'           => '',
				'simple_page_block_title_font_style'     => '',
				'simple_page_block_title_color'          => '',
				'simple_page_block_title_font_size'      => '',
				'simple_page_block_title_line_height'    => '',
				'simple_page_block_title_letter_spacing' => '',
				'simple_page_block_desc_font'            => '',
				'simple_page_block_desc_font_style'      => '',
				'simple_page_block_desc_color'           => '',
				'simple_page_block_desc_font_size'       => '',
				'simple_page_block_desc_line_height'     => '',
				'simple_page_block_desc_letter_spacing'  => '',
				'module_animation'                       => '',
				'el_class'                               => '',
			), $atts ) );


			// Animation TODO
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$id = uniqid( 'st-simple-page-block-' );

			$img      = wp_get_attachment_image_src( $atts['simple_page_block_img'], 'full' );
			$img_link = $img[0];
			if ( $img ) {
				$bg_style = ' style="background-image:url(' . esc_url( $img_link ) . ')"';
			}

			$simple_page_block_href = vc_build_link( $simple_page_block_link );
			if ( $simple_page_block_href !== '' ) {
				$simple_page_block_link_url    = ( $simple_page_block_href['url'] !== '' ) ? esc_url( $simple_page_block_href['url'] ) : '';
				$simple_page_block_link_target = ( $simple_page_block_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $simple_page_block_href['target'] ) ) . '"' : '';
				$simple_page_block_link_title  = ( $simple_page_block_href['title'] !== '' ) ? 'title="' . esc_attr( $simple_page_block_href['title'] ) . '"' : '';

				if ( ! empty( $simple_page_block_href['rel'] ) ) {
					$rel = ' rel="' . esc_attr( $simple_page_block_href['rel'] ) . '"';
				} else {
					$rel = '';
				}
			} else {
				$simple_page_block_link_url = '';
			}

			// Simple page block title
			$simple_page_block_title_style = 'style="';

			if ( $simple_page_block_title_font !== '' ) {
				$simple_page_block_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $simple_page_block_title_font ) : '';
				$simple_page_block_title_style       .= ! empty( $simple_page_block_title_font_family ) ? 'font-family:\'' . $simple_page_block_title_font_family . '\';' : '';
			}

			if ( is_numeric( $simple_page_block_title_font_size ) ) {
				$simple_page_block_title_font_size = 'desktop: ' . $simple_page_block_title_font_size . 'px;';
			}
			if ( is_numeric( $simple_page_block_title_line_height ) ) {
				$simple_page_block_title_line_height = 'desktop: ' . $simple_page_block_title_line_height . 'px;';
			}

			$simple_page_block_title_args = array(
				'target'      => '#' . $id . ' .st-simple-page-block-title',
				'media_sizes' => array(
					'font-size'   => $simple_page_block_title_font_size,
					'line-height' => $simple_page_block_title_line_height,
				),
			);

			$simple_page_block_title_responsive = get_ultimate_vc_responsive_media_css( $simple_page_block_title_args );
			$simple_page_block_title_style      .= $simple_page_block_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $simple_page_block_title_letter_spacing ) . 'px;' : '';
			$simple_page_block_title_style      .= '"';

			// Simple page block description
			$simple_page_block_desc_style = 'style="';

			if ( $simple_page_block_desc_font !== '' ) {
				$simple_page_block_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $simple_page_block_desc_font ) : '';
				$simple_page_block_desc_style       .= ! empty( $simple_page_block_desc_font_family ) ? 'font-family:\'' . $simple_page_block_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $simple_page_block_desc_font_size ) ) {
				$simple_page_block_desc_font_size = 'desktop: ' . $simple_page_block_desc_font_size . 'px;';
			}
			if ( is_numeric( $simple_page_block_desc_line_height ) ) {
				$simple_page_block_desc_line_height = 'desktop: ' . $simple_page_block_desc_line_height . 'px;';
			}

			$simple_page_block_desc_args = array(
				'target'      => '#' . $id . ' .st-simple-page-block-desc',
				'media_sizes' => array(
					'font-size'   => $simple_page_block_desc_font_size,
					'line-height' => $simple_page_block_desc_line_height,
				),
			);

			$simple_page_block_desc_responsive = get_ultimate_vc_responsive_media_css( $simple_page_block_desc_args );
			$simple_page_block_desc_style      .= $simple_page_block_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $simple_page_block_desc_letter_spacing ) . 'px;' : '';
			$simple_page_block_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-simple-page-block ' . esc_attr( $el_class ) . ' ' . $animated . '" ' . $animation . ' id="' . esc_attr( $id ) . '">';
			if ( '' !== $simple_page_block_link_url ) {
				$output .= '<a href="' . esc_url( $simple_page_block_href['url'] ) . '" ' . $simple_page_block_link_title . ' ' . $simple_page_block_link_target . ' ' . $rel . '>';
			}
			$output .= '<div class="st-simple-page-block-title ult-responsive" ' . $simple_page_block_title_style . ' ' . $simple_page_block_title_responsive . '><h3><i class="st-h-before"><i></i></i>' . esc_attr( $simple_page_block_title ) . '</h3></div>';
			if ( '' !== $simple_page_block_link_url ) {
				$output .= '</a>';
			}
			$output .= '<div class="st-simple-page-block-inner">';
			if ( '' !== $simple_page_block_link_url ) {
				$output .= '<a href="' . esc_url( $simple_page_block_href['url'] ) . '" ' . $simple_page_block_link_title . ' ' . $simple_page_block_link_target . ' ' . $rel . '>';
			}
			$output .= '<div class="st-simple-page-block-thumbnail" ' . $bg_style . '><div class="st-simple-page-block-overlay"><div class="overlay-inner-icon"></div><div class="overlay-inner-left"></div><div class="overlay-inner-right"></div></div></div>';
			if ( '' !== $simple_page_block_link_url ) {
				$output .= '</a>';
			}
			$output .= '<div class="st-simple-page-block-info">';
			$output .= '<div class="st-simple-page-block-desc">' . do_shortcode( $content ) . '</div>';
			if ( '' !== $simple_page_block_link_url ) {
				$output .= '<a class="st-simple-page-block-link" href="' . esc_url( $simple_page_block_href['url'] ) . '" ' . $simple_page_block_link_title . ' ' . $simple_page_block_link_target . ' ' . $rel . '>' . esc_html__( 'Read more', 'adamas-vc-shortcodes' ) . '</a>';
			}
			$output .= '</div>'; // st-simple-page-block-info
			$output .= '</div>'; // st-simple-page-block-inner
			$output .= '</div>'; // st-simple-page-block

			return $output;
		}

		function simple_page_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Simple Page Block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_simple_page_block_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/simple_page_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays block with title, thumbnail and excerpt', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Thumbnail', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_img',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title',
							'description' => '',
							'admin_label' => true
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_link',
							'description' => ''
						),

						// Simple page block title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Simple page block description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'simple_page_block_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_simple_page_block_module = new St_Simple_Page_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_simple_page_block_module extends WPBakeryShortCode {
		}
	}
}