<?php
/*
* Add-on Name: Social Buttons Module
*/
if ( ! class_exists( 'St_Social_Buttons_Module' ) ) {
	class St_Social_Buttons_Module {
		function __construct() {
			add_shortcode( 'st_social_buttons_module', array( $this, 'social_buttons_module_shortcode' ) );
			add_action( 'init', array( $this, 'social_buttons_module_init' ) );
		}

		function social_buttons_module_shortcode( $atts ) {
			$output = $st_social_buttons_facebook = $st_social_buttons_twitter = $st_social_buttons_googleplus = $st_social_buttons_pinterest = $st_social_buttons_linkedin = $st_social_buttons_instagram = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'st_social_buttons_facebook'   => '',
				'st_social_buttons_twitter'    => '',
				'st_social_buttons_googleplus' => '',
				'st_social_buttons_pinterest'  => '',
				'st_social_buttons_linkedin'   => '',
				'st_social_buttons_instagram'  => '',
				'module_animation'             => '',
				'el_class'                     => '',
			), $atts ) );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$output .= '<div class="st-social-buttons ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
			$output .= '<div class="st-social-buttons-inner">';

			if ( $st_social_buttons_facebook !== '' ) {
				$facebook_href = vc_build_link( $st_social_buttons_facebook );
				if ( $facebook_href !== '' ) {
					$facebook_target = ( $facebook_href['target'] !== '' ) ? "target='" . esc_attr( trim( $facebook_href['target'] ) ) . "'" : '';
					$facebook_title  = ( $facebook_href['title'] !== '' ) ? "title='" . esc_attr( $facebook_href['title'] ) . "'" : '';
					if ( ! empty( $facebook_href['rel'] ) ) {
						$facebook_rel = ' rel="' . esc_attr( $facebook_href['rel'] ) . '"';
					} else {
						$facebook_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-facebook" href="' . esc_url( $facebook_href['url'] ) . '" ' . $facebook_title . ' ' . $facebook_target . ' ' . $facebook_rel . '><span>Facebook</span><i class="fa fa-facebook" aria-hidden="true"></i></a></div>';
				}
			}

			if ( $st_social_buttons_twitter !== '' ) {
				$twitter_href = vc_build_link( $st_social_buttons_twitter );
				if ( $twitter_href !== '' ) {
					$twitter_target = ( $twitter_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $twitter_href['target'] ) ) . '"' : '';
					$twitter_title  = ( $twitter_href['title'] !== '' ) ? 'title="' . esc_attr( $twitter_href['title'] ) . '"' : '';
					if ( ! empty( $twitter_href['rel'] ) ) {
						$twitter_rel = ' rel="' . esc_attr( $twitter_href['rel'] ) . '"';
					} else {
						$twitter_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-twitter" href="' . esc_url( $twitter_href['url'] ) . '" ' . $twitter_title . ' ' . $twitter_target . ' ' . $twitter_rel . '><span>Twitter</span><i class="fa fa-twitter" aria-hidden="true"></i></a></div>';
				}
			}

			if ( $st_social_buttons_googleplus !== '' ) {
				$googleplus_href = vc_build_link( $st_social_buttons_googleplus );
				if ( $googleplus_href !== '' ) {
					$googleplus_target = ( $googleplus_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $googleplus_href['target'] ) ) . '"' : '';
					$googleplus_title  = ( $googleplus_href['title'] !== '' ) ? 'title="' . esc_attr( $googleplus_href['title'] ) . '"' : '';
					if ( ! empty( $googleplus_href['rel'] ) ) {
						$googleplus_rel = ' rel="' . esc_attr( $googleplus_href['rel'] ) . '"';
					} else {
						$googleplus_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-googleplus" href="' . esc_url( $googleplus_href['url'] ) . '" ' . $googleplus_title . ' ' . $googleplus_target . ' ' . $googleplus_rel . '><span>Google Plus</span><i class="fa fa-google-plus" aria-hidden="true"></i></a></div>';
				}
			}

			if ( $st_social_buttons_pinterest !== '' ) {
				$pinterest_href = vc_build_link( $st_social_buttons_pinterest );
				if ( $pinterest_href['url'] !== '' ) {
					$pinterest_target = ( $pinterest_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $pinterest_href['target'] ) ) . '"' : '';
					$pinterest_title  = ( $pinterest_href['title'] !== '' ) ? 'title="' . esc_attr( $pinterest_href['title'] ) . '"' : '';
					if ( ! empty( $pinterest_href['rel'] ) ) {
						$pinterest_rel = ' rel="' . esc_attr( $pinterest_href['rel'] ) . '"';
					} else {
						$pinterest_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-pinterest" href="' . esc_url( $pinterest_href['url'] ) . '" ' . $pinterest_title . ' ' . $pinterest_target . ' ' . $pinterest_rel . '><span>Pinterest</span><i class="fa fa-pinterest-p" aria-hidden="true"></i></a></div>';
				}
			}

			if ( $st_social_buttons_linkedin !== '' ) {
				$linkedin_href = vc_build_link( $st_social_buttons_linkedin );
				if ( $linkedin_href !== '' ) {
					$linkedin_target = ( $linkedin_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $linkedin_href['target'] ) ) . '"' : '';
					$linkedin_title  = ( $linkedin_href['title'] !== '' ) ? 'title="' . esc_attr( $linkedin_href['title'] ) . '"' : '';
					if ( ! empty( $linkedin_href['rel'] ) ) {
						$linkedin_rel = ' rel="' . esc_attr( $linkedin_href['rel'] ) . '"';
					} else {
						$linkedin_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-linkedin" href="' . esc_url( $linkedin_href['url'] ) . '" ' . $linkedin_title . ' ' . $linkedin_target . ' ' . $linkedin_rel . '><span>Linked In</span><i class="fa fa-linkedin" aria-hidden="true"></i></a></div>';
				}
			}

			if ( $st_social_buttons_instagram !== '' ) {
				$instagram_href = vc_build_link( $st_social_buttons_instagram );
				if ( $instagram_href !== '' ) {
					$instagram_target = ( $instagram_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $instagram_href['target'] ) ) . '"' : '';
					$instagram_title  = ( $instagram_href['title'] !== '' ) ? 'title="' . esc_attr( $instagram_href['title'] ) . '"' : '';
					if ( ! empty( $instagram_href['rel'] ) ) {
						$instagram_rel = ' rel="' . esc_attr( $instagram_href['rel'] ) . '"';
					} else {
						$instagram_rel = '';
					}
					$output .= '<div class="st-social-buttons-item"><a class="st-social-buttons-instagram" href="' . esc_url( $instagram_href['url'] ) . '" ' . $instagram_title . ' ' . $instagram_target . ' ' . $instagram_rel . '><span>Instagram</span><i class="fa fa-instagram" aria-hidden="true"></i></a></div>';
				}
			}

			$output .= '</div>'; // st-social-buttons-inner
			$output .= '</div>'; // st-social-buttons

			return $output;
		}

		function social_buttons_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Social Buttons', 'adamas-vc-shortcodes' ),
					'base'        => 'st_social_buttons_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/social_buttons.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays social buttons.', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Facebook link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'st_social_buttons_facebook',
							'description' => '',
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Twitter link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'st_social_buttons_twitter',
							'description' => '',
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Google Plus link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'st_social_buttons_googleplus',
							'description' => '',
						),
						array(
							'type'       => 'vc_link',
							'heading'    => __( 'Pinterest link', 'adamas-vc-shortcodes' ),
							'param_name' => 'st_social_buttons_pinterest',
						),
						array(
							'type'       => 'vc_link',
							'heading'    => __( 'LinkedIn link', 'adamas-vc-shortcodes' ),
							'param_name' => 'st_social_buttons_linkedin',
						),
						array(
							'type'       => 'vc_link',
							'heading'    => __( 'Instagram link', 'adamas-vc-shortcodes' ),
							'param_name' => 'st_social_buttons_instagram',
						),
						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_social_buttons_module = new St_Social_Buttons_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_social_buttons_module extends WPBakeryShortCode {
		}
	}
}