<?php
/*
* Add-on Name: Team Member Block Module
*/
if ( ! class_exists( 'St_Team_Member_Block_Module' ) ) {
	class St_Team_Member_Block_Module {
		function __construct() {
			add_shortcode( 'st_team_member_block_module', array( $this, 'team_member_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'team_member_block_module_init' ) );
		}

		function team_member_block_module_shortcode( $atts, $content ) {
			$output = $bg_img = $team_member_style = $team_member_layout = $team_member_photo_height = $team_member_link = $team_member_name = $team_member_occupation = $team_member_phone = $team_member_phone_2 = $team_member_skype = $team_member_email = $team_member_photo = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'team_member_layout'                    => '',
				'team_member_photo_height'              => '',
				'team_member_name'                      => '',
				'team_member_name_font'                 => '',
				'team_member_name_font_style'           => '',
				'team_member_name_color'                => '',
				'team_member_name_color_hover'          => '',
				'team_member_name_font_size'            => '',
				'team_member_name_line_height'          => '',
				'team_member_name_letter_spacing'       => '',
				'team_member_occupation'                => '',
				'team_member_occupation_font'           => '',
				'team_member_occupation_font_style'     => '',
				'team_member_occupation_color'          => '',
				'team_member_occupation_font_size'      => '',
				'team_member_occupation_line_height'    => '',
				'team_member_occupation_letter_spacing' => '',
				'team_member_desc_font'                 => '',
				'team_member_desc_font_size'            => '',
				'team_member_desc_line_height'          => '',
				'team_member_desc_letter_spacing'       => '',
				'team_member_phone'                     => '',
				'team_member_phone_2'                   => '',
				'team_member_skype'                     => '',
				'team_member_email'                     => '',
				'team_member_photo'                     => '',
				'team_member_link'                      => '',
				'module_animation'                      => '',
				'el_class'                              => '',
			), $atts ) );


			// Animation TODO :
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			if ( $team_member_layout == '' ) {
				$team_member_layout = 'ext';
			}

			if ( $team_member_layout != '' ) {
				$el_class .= ' ' . $team_member_layout;
			}

			$id = uniqid( 'st-team-member-block-' );

			$team_member_href        = vc_build_link( $team_member_link );
			$team_member_link_url    = ( $team_member_href['url'] !== '' ) ? esc_url( $team_member_href['url'] ) : '';
			$team_member_link_target = ( $team_member_href['target'] !== '' ) ? "target='" . esc_attr( trim( $team_member_href['target'] ) ) . "'" : '';
			$team_member_link_title  = ( $team_member_href['title'] !== '' ) ? "title='" . esc_attr( $team_member_href['title'] ) . "'" : '';
			if ( ! empty( $team_member_href['rel'] ) ) {
				$rel = ' rel="' . esc_attr( $team_member_href['rel'] ) . '"';
			} else {
				$rel = '';
			}

			$img      = wp_get_attachment_image_src( $atts['team_member_photo'], 'full' );
			$img_link = $img[0];

			$team_member_style .= ' style="';

			if ( $team_member_photo_height ) {
				$team_member_style .= 'height:' . esc_attr( $team_member_photo_height ) . 'px;';
			}

			if ( $img ) {
				$team_member_style .= 'background-image:url(' . esc_url( $img_link ) . ');';
			}

			$team_member_style .= '"';

			// Team member name
			$team_member_name_style = 'style="';

			if ( $team_member_name_font !== '' ) {
				$team_member_name_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $team_member_name_font ) : '';
				$team_member_name_style       .= ! empty( $team_member_name_font_family ) ? 'font-family:\'' . $team_member_name_font_family . '\';' : '';
			}
			if ( $team_member_name_font_style !== '' ) {
				$team_member_name_style .= esc_attr( $team_member_name_font_style );
			}

			if ( is_numeric( $team_member_name_font_size ) ) {
				$team_member_name_font_size = 'desktop: ' . $team_member_name_font_size . 'px;';
			}
			if ( is_numeric( $team_member_name_line_height ) ) {
				$team_member_name_line_height = 'desktop: ' . $team_member_name_line_height . 'px;';
			}

			$team_member_name_args = array(
				'target'      => '#' . $id . ' .st-team-member-name',
				'media_sizes' => array(
					'font-size'   => $team_member_name_font_size,
					'line-height' => $team_member_name_line_height,
				),
			);

			$team_member_name_responsive = get_ultimate_vc_responsive_media_css( $team_member_name_args );
			$team_member_name_style      .= $team_member_name_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $team_member_name_letter_spacing ) . 'px;' : '';
			$team_member_name_style      .= $team_member_name_color !== '' ? 'color:' . esc_attr( $team_member_name_color ) . ';' : '';
			$team_member_name_style      .= '"';

			// Team member occupation
			$team_member_occupation_style = 'style="';

			if ( $team_member_occupation_font !== '' ) {
				$team_member_occupation_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $team_member_occupation_font ) : '';
				$team_member_occupation_style       .= ! empty( $team_member_occupation_font_family ) ? 'font-family:\'' . $team_member_occupation_font_family . '\';' : '';
			}
			if ( $team_member_occupation_font_style !== '' ) {
				$team_member_occupation_style .= esc_attr( $team_member_occupation_font_style );
			}

			if ( is_numeric( $team_member_occupation_font_size ) ) {
				$team_member_occupation_font_size = 'desktop: ' . $team_member_occupation_font_size . 'px;';
			}
			if ( is_numeric( $team_member_occupation_line_height ) ) {
				$team_member_occupation_line_height = 'desktop: ' . $team_member_occupation_line_height . 'px;';
			}

			$team_member_occupation_args = array(
				'target'      => '#' . $id . ' .st-team-member-occupation',
				'media_sizes' => array(
					'font-size'   => $team_member_occupation_font_size,
					'line-height' => $team_member_occupation_line_height,
				),
			);

			$team_member_occupation_responsive = get_ultimate_vc_responsive_media_css( $team_member_occupation_args );
			$team_member_occupation_style      .= $team_member_occupation_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $team_member_occupation_letter_spacing ) . 'px;' : '';
			$team_member_occupation_style      .= $team_member_occupation_color !== '' ? 'color:' . esc_attr( $team_member_occupation_color ) . ';' : '';
			$team_member_occupation_style      .= '"';

			// Team member description
			$team_member_desc_style = 'style="';

			if ( $team_member_desc_font !== '' ) {
				$team_member_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $team_member_desc_font ) : '';
				$team_member_desc_style       .= ! empty( $team_member_desc_font_family ) ? 'font-family:\'' . $team_member_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $team_member_desc_font_size ) ) {
				$team_member_desc_font_size = 'desktop: ' . $team_member_desc_font_size . 'px;';
			}
			if ( is_numeric( $team_member_desc_line_height ) ) {
				$team_member_desc_line_height = 'desktop: ' . $team_member_desc_line_height . 'px;';
			}

			$team_member_desc_args = array(
				'target'      => '#' . $id . ' .st-team-member-desc',
				'media_sizes' => array(
					'font-size'   => $team_member_desc_font_size,
					'line-height' => $team_member_desc_line_height,
				),
			);

			$team_member_desc_responsive = get_ultimate_vc_responsive_media_css( $team_member_desc_args );
			$team_member_desc_style      .= $team_member_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $team_member_desc_letter_spacing ) . 'px;' : '';
			$team_member_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-team-member-block ' . esc_attr( $el_class ) . ' ' . $animated . '" id="' . esc_attr( $id ) . '" ' . $animation . '>';
			if ( $team_member_link_url !== '' ) {
				$output .= '<a href="' . $team_member_link_url . '" ' . $team_member_link_title . ' ' . $team_member_link_target . ' ' . $rel . '>';
			}
			$output .= '<div class="st-team-member-block-photo" ' . $team_member_style . '><div class="st-team-member-block-photo-overlay"><div class="overlay-inner-icon"></div><div class="overlay-inner-left"></div><div class="overlay-inner-right"></div></div></div>';
			if ( $team_member_link_url !== '' ) {
				$output .= '</a>';
			}
			$output .= '<div class="st-team-member-block-info ' . $animated . '" ' . $animation . '>';
			$output .= '<div class="st-team-member-name ult-responsive" ' . $team_member_name_style . ' ' . $team_member_name_responsive . '>';
			if ( $team_member_link_url !== '' ) {
				$output .= '<a href="' . $team_member_link_url . '" ' . $team_member_link_title . ' ' . $team_member_link_target . ' ' . $rel . '>';
			}
			$output .= esc_attr( $team_member_name );
			if ( $team_member_link_url !== '' ) {
				$output .= '</a>';
			}
			$output .= '</div>'; // st-team-member-name
			$output .= '<div class="st-team-member-occupation ult-responsive" ' . $team_member_occupation_style . ' ' . $team_member_occupation_responsive . '>' . esc_attr( $team_member_occupation ) . '</div>';
			if ( $team_member_layout == 'ext' ) {
				$output .= '<div class="st-team-member-desc">' . do_shortcode( $content ) . '</div>';
				$output .= '<div class="st-team-member-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone ) ) . '">' . esc_attr( $team_member_phone ) . '</a></div>';
				$output .= '<div class="st-team-member-email"><i class="fa fa-envelope" aria-hidden="true"></i><a href="mailto:' . sanitize_email( $team_member_email ) . '">' . sanitize_email( $team_member_email ) . '</a></div>';
			} elseif ( $team_member_layout == 'simple-info' ) {
				if ( $team_member_phone !== '' ) {
					$output .= '<div class="st-team-member-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone ) ) . '">' . esc_attr( $team_member_phone ) . '</a></div>';
				}
				if ( $team_member_phone_2 !== '' ) {
					$output .= '<div class="st-team-member-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone_2 ) ) . '">' . esc_attr( $team_member_phone_2 ) . '</a></div>';
				}
				if ( $team_member_skype !== '' ) {
					$output .= '<div class="st-team-member-skype"><i class="fa fa-skype" aria-hidden="true"></i><a href="callTo:' . esc_attr( $team_member_skype ) . '">' . esc_attr( $team_member_skype ) . '</a></div>';
				}
				if ( $team_member_email !== '' ) {
					$output .= '<div class="st-team-member-email"><i class="fa fa-envelope" aria-hidden="true"></i><a href="mailto:' . sanitize_email( $team_member_email ) . '">' . sanitize_email( $team_member_email ) . '</a></div>';
				}
			}
			$output .= '</div>'; // st-team-member-block-info
			$output .= '</div>'; // st-team-member-block

			$hover_style = '';
			if ( $team_member_name_color_hover != '' ) {
				$hover_style .= '<style type="text/css">';
				$hover_style .= '#' . esc_attr( $id ) . ' .st-team-member-name:hover a{color:' . esc_attr( $team_member_name_color_hover ) . ' !important} ';
				$hover_style .= '</style>';
			}

			if ( $hover_style != '' ) {
				$output .= "<script type=\"text/javascript\">jQuery(document).ready(function(){jQuery('head').append('" . $hover_style . "');});</script>";
			}

			return $output;
		}

		function team_member_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Team Member Block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_team_member_block_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/team_member_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays team member info', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Block layout', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_layout',
							'value'       => array(
								__( 'Extended', 'adamas-vc-shortcodes' )                 => 'ext',
								__( 'Simple', 'adamas-vc-shortcodes' )                   => 'simple',
								__( 'Simple with contact info', 'adamas-vc-shortcodes' ) => 'simple-info',
							),
							'description' => __( 'Select layout for team member block: Simple - photo with name and occupation. Extended - simple with description and contact data.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'vc_link',
							'class'       => '',
							'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_link',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name',
							'description' => '',
							'admin_label' => true,
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Occupation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation',
							'description' => '',
						),
						array(
							'type'        => 'textarea_html',
							'class'       => '',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => 'ext' ),
						),
						array(
							'type'        => 'attach_image',
							'class'       => '',
							'heading'     => __( 'Photo', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_photo',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Photo height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_photo_height',
							'description' => __( 'Set height of photo in px.', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => 'simple' ),
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Phone', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_phone',
							'description' => '',
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => array( 'ext', 'simple-info' ) ),
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Phone 2', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_phone_2',
							'description' => '',
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => 'simple-info' ),
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Skype', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_skype',
							'description' => '',
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => 'simple-info' ),
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Email', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_email',
							'description' => '',
							'dependency'  => Array( 'element' => 'team_member_layout', 'value' => array( 'ext', 'simple-info' ) ),
						),

						// Team member name typography
						array(
							'type'        => 'ultimate_google_fonts',
							'class'       => '',
							'heading'     => __( 'Name font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'class'       => '',
							'heading'     => __( 'Name font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'class'       => '',
							'heading'     => __( 'Name font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'class'       => '',
							'heading'     => __( 'Name font color on hover', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_color_hover',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Name letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Team member occupation typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Occupation font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Occupation font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Occupation font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Occupation font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Occupation line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Occupation letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_occupation_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Team member description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_team_member_block_module = new St_Team_Member_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_team_member_block_module extends WPBakeryShortCode {
		}
	}
}