<?php
/*
Add-on Name: Advanced Tab
* Add-on URI: http://dev.brainstormforce.com
*/

if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}
if ( ! class_exists( 'ULT_TAB_ELEMENT' ) ) {
	class ULT_TAB_ELEMENT {
		function __construct() {
			if ( Ultimate_VC_Addons::$uavc_editor_enable ) {
				add_action( 'init', array( $this, 'ult_tab_init' ) );
			}
			add_action( 'wp_enqueue_scripts', 'ultimate_tabs', 1 );
			add_action( 'admin_print_scripts', 'ultimate_tabs_admin', 999 );
			add_shortcode( 'ult_tab_element', array( $this, 'ultimate_main_tab' ) );
			add_shortcode( 'single_tab', array( $this, 'ultimate_single_tab' ) );
		}

		function ultimate_single_tab( $atts, $content = null ) {
			$output      = $title = $tab_id = $font_icons_position = $icon_type = $icon = $icon_color = $icon_hover_color =
			$icon_size = $icon_background_color = $icon_margin_bottom = $icon_margin_left = $icon_margin = $ul_sub_class = '';
			$icon_border = $icon_border_color_hover = $icon_border_color_active = '';

			//extract(shortcode_atts($this->predefined_atts, $atts));
			extract( shortcode_atts( array(
				'title'                    => ' ',
				'tab_id'                   => ' ',
				'subtab_bg_image'          => ' ',
				'font_icons_position'      => ' ',
				'icon_type'                => ' ',
				'icon'                     => ' ',
				'icon_img'                 => ' ',
				'icon_color'               => ' ',
				'icon_hover_color'         => ' ',
				'icon_size'                => ' ',
				'icon_margin'              => ' ',
				'icon_border'              => '',
				'icon_border_color_hover'  => '',
				'icon_border_color_active' => '',
				'icon_bg_size'             => '',
				'ul_sub_class'             => '',
			), $atts ) );
			//wp_enqueue_script('jquery_ui_tabs_rotate');
			//wp_enqueue_script('imd_ui_tabs_rotate');
			//echo $content = wpb_js_remove_wpautop($content, true);
			global $tabarr;

			$tabarr[] = array(
				'title'                    => $title,
				'tab_id'                   => $tab_id,
				'subtab_bg_image'          => $subtab_bg_image,
				'font_icons_position'      => $font_icons_position,
				'icon_type'                => $icon_type,
				'icon'                     => $icon,
				'icon_img'                 => $icon_img,
				'icon_color'               => $icon_color,
				'icon_hover_color'         => $icon_hover_color,
				'icon_size'                => $icon_size,
				'content'                  => $content,
				'icon_margin'              => $icon_margin,
				'icon_border'              => $icon_border,
				'icon_bg_size'             => $icon_bg_size,
				'icon_border_color_active' => $icon_border_color_active,
				'icon_border_color_hover'  => $icon_border_color_hover,
				'ul_sub_class'             => $ul_sub_class,
			);

			$subtab_bg_image = wp_get_attachment_image_src( $subtab_bg_image, 'full' );
			if ( $subtab_bg_image ) {
				$bg_link = $subtab_bg_image[0];
				$bg      = '<div class="st-adv-tab-bg" style="background-image: url(' . $bg_link . ')"></div>';
			} else {
				$bg = ' ';
			}

			if ( current_user_can( 'editor' ) || current_user_can( 'administrator' ) ) {

				$admn = "Empty tab. Edit page to add content here.";
			} else {
				$admn = "";
			}
			$tabcont = wpb_js_remove_wpautop( $content );


			$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, 'wpb_tab ui-tabs-panel wpb_ui-tabs-hide vc_clearfix ult_back', 'single_tab', $atts );
			$output    .= "\n\t\t\t" . '<div  class="ult_tabitemname"  >';
			$output    .= $bg;
			$output    .= ( $content == '' || $content == ' ' ) ? __( $admn, "adamas-vc-shortcodes" ) : "\n\t\t\t\t" . wpb_js_remove_wpautop( $content );
			$output    .= "\n\t\t\t" . '</div>';

			//do_shortcode($content);
			return $output;

		}

		function ultimate_main_tab( $atts, $content ) {

			$output = $title = $interval = $el_class = $shadow_color = $shadow_width = '';
			extract( shortcode_atts( array(
				//'maintitle' => '',
				'title_color'                => '',
				'auto_rotate'                => '',
				'interval'                   => 0,
				'tab_style'                  => 'Style_1',
				'tab_bottom_border'          => 'Disable',
				'border_color'               => '#1e73be',
				'border_thickness'           => '2',
				'tabs_list_color'            => '',
				'tab_title_color'            => '#74777b',
				'tab_hover_title_color'      => '#ffffff',
				'tab_background_color'       => '#e7ecea',
				'tab_hover_background_color' => '#4f90d1',
				'container_width'            => '',
				'el_class'                   => '',
				'container_width'            => '',
				'main_heading_font_family'   => '',
				'title_font_size'            => '15',
				'title_font_wt'              => '',
				'title_line_ht'              => '',
				'desc_font_family'           => '',
				'desc_font_size'             => '',
				'desc_font_style'            => '',
				'desc_line_ht'               => '',
				'shadow_color'               => '#333333',
				'shadow_width'               => '',
				'enable_bg_color'            => '',
				'container_border_style1'    => '',
				'container_color_border'     => '',
				'cont_border_size'           => '',
				'tabs_border_radius'         => '8',
				'tabs_padding'               => '',
				'tabs_active_index'          => '1',
				'tab_animation'              => 'Slide',
				'tab_describe_color'         => '#74777b',
				'title_font_style'           => '',
				'css'                        => '',
				'act_icon_color'             => '',
				'acttab_background'          => '',
				'acttab_title'               => '',
				'resp_type'                  => 'Tabs',
				'resp_width'                 => '400',
				'resp_style'                 => 'Both',
				'ac_tabs'                    => '',
				'icon_color'                 => '#74777b',
				'icon_hover_color'           => '#ffffff',
				'icon_size'                  => '15',
				'icon_margin'                => '',
				'icon_border'                => '',
				'icon_bg_size'               => '',
				'icon_border_color_active'   => '',
				'icon_border_color_hover'    => '',
				'disp_icon'                  => 'Enable',
				'tab_css'                    => ' ',
				'font_icons_position'        => 'Right',
				'main_title_typograpy'       => '',
				'tab_max'                    => 'off',
				'wrapper_margin'             => '',
				'smooth_scroll'              => 'on',
				'tab_nav_full_width'         => '',
				'tab_nav_item_eq_width'      => '',
				'active_tab_marker'          => '',
			), $atts ) );
			global $tabarr;
			$tabarr = array();
			do_shortcode( $content );

			/*-----------default settings------------*/

			if ( $acttab_background == '' ) {
				$acttab_background = $tab_hover_background_color;
			}
			if ( $acttab_title == '' ) {
				$acttab_title = $tab_hover_title_color;
			}

			/*---------------padding---------------------*/
			$css_class = '';
			$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css, ' ' ), "ult_tab_element", $atts );
			$css_class = esc_attr( $css_class );


			if ( $tabs_border_radius != '' ) {
				//echo $tabs_border_radius;
			}
			/*-------------------font style------------------*/
			if ( $tab_style == 'Style_5' ) {
				//$tab_bottom_border=='Enable';
			}

			$container_style = $ult_style = $tab_style_no = '';
			if ( $tab_bottom_border == 'Disable' ) {
				$border_thickness = "0";
				$border_color     = "transparent";
			}
			if ( $container_width != '' ) {
				$container_style = 'max-width:' . $container_width . 'px;';
			}
			$border_Style = $mhfont_family = $border_style = '';

			$tabs_nav_style = '';

// if($title_font_size!='')
// $tabs_nav_style .= 'font-size:'.$title_font_size.'px;';
// if($title_line_ht!='')
// $tabs_nav_style .='line-height:'.$title_line_ht.'px;';

			if ( is_numeric( $title_font_size ) ) {
				$title_font_size = 'desktop:' . $title_font_size . 'px;';
			}

			if ( is_numeric( $title_line_ht ) ) {
				$title_line_ht = 'desktop:' . $title_line_ht . 'px;';
			}

			$advanced_tabs_id = 'advanced-tabs-wrap-' . rand( 1000, 9999 );

			$advanced_tabs_args = array(
				'target'      => '#' . $advanced_tabs_id . ' .ult-span-text', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $title_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $title_line_ht
				),
			);

			$advanced_tabs_data_list = get_ultimate_vc_responsive_media_css( $advanced_tabs_args );

			if ( function_exists( 'get_ultimate_font_family' ) ) {

				$mhfont_family = get_ultimate_font_family( $main_heading_font_family );
				if ( $mhfont_family != '' ) {
					$tabs_nav_style .= 'font-family:' . $mhfont_family . ';';
				}

			}
			if ( function_exists( 'get_ultimate_font_style' ) ) {
				if ( $title_font_style != '' ) {
					$tabs_nav_style .= get_ultimate_font_style( $title_font_style );
				}
			}

			/*-------------------auto rotate------------------*/

			if ( $auto_rotate == 'Disables' ) {
				$interval   = 0;
				$autorotate = 'no';
			} else {
				$autorotate = 'yes';
			}

			if ( $tab_background_color == '' ) {
				$tab_background_color = "transparent";
			}

			$element = 'wpb_tabs';
//if ( 'vc_tour' == $this->shortcode ) $element = 'wpb_tour';
			$ul_style = $tabs_nav = $style = '';

			/*------------------- style------------------*/

			if ( $tab_style == 'Style_1' ) {

				$style = 'style1';
			} else if ( $tab_style == 'Style_2' ) {

				$style = 'style2';

			} else if ( $tab_style == 'Style_3' ) {

				$style = 'style3';

			} else if ( $tab_style == 'Style_4' ) {
				$ult_style = 'ult_tab_style_4';
				$style     = 'style1';
			} else if ( $tab_style == 'Style_5' ) {
				$ult_style = 'ult_tab_style_5';
				$style     = 'style1';
			} else if ( $tab_style == 'Style_6' ) {
				$ult_style = 'ult_tab_style_6';
				$style     = 'style1';
			} else if ( $tab_style == 'Adamas_Style' ) {
				$ult_style = 'st_adamas_tab_style';
				$style     = 'style1';
			} else if ( $tab_style == 'Adamas_Style_2' ) {
				$ult_style = 'st_adamas_tab_style_2';
				$style     = 'style1';
			}
			foreach ( $tabarr as $key => $value ) {
				$icon_value = $value["icon_size"];
				if ( is_numeric( $icon_value ) ) {
					$icon_value1[] = $value["icon_size"];
				}
			}


			/*-------------- border style-----------*/
			$tab_border = '';
			$tab_border .= 'color:' . $border_color . ';';
			$tab_border .= 'border-bottom-color:' . $border_color . ';';
			$tab_border .= 'border-bottom-width:' . $border_thickness . 'px;';
			$tab_border .= 'border-bottom-style:solid;';
			if ( $tab_style == 'Style_1' || $tab_style == 'Style_3' ) {
				$tab_border .= 'background-color:' . $tab_background_color . ';';
				$tab_border .= 'border-top-left-radius:' . $tabs_border_radius . 'px;';
				$tab_border .= 'border-top-right-radius:' . $tabs_border_radius . 'px;';
				$tab_border = '';
			}
			if ( $tab_style == 'Style_2' ) {
				$tab_border .= 'border-bottom-width:0px;';
			}
			if ( $tab_style == 'Style_4' || $tab_style == 'Style_5' || $tab_style == 'Style_6' ) {
				$tab_border .= 'border-bottom-width:0px;';

			}
			if ( $tab_style == 'Adamas_Style' ) {
				$tab_border .= 'border-bottom-width:1px;';
				$tab_border .= 'border-bottom-color:#ffffff;';
			}

			if ( $tabs_list_color ) {
				$tabs_list_bg = 'background:' . $tabs_list_color . '';
			}
			/*-----------------content baground-------------------*/

			$contain_bg = '';

			/*---------------- description font family-----------*/
// if($desc_font_size!='')
// $contain_bg .= 'font-size:'.$desc_font_size.'px;';
// if($title_line_ht!='')
// $contain_bg .='line-height:'.$desc_line_ht.'px;';

//responsive param

			if ( is_numeric( $desc_font_size ) ) {
				$desc_font_size = 'desktop:' . $desc_font_size . 'px;';
			}

			if ( is_numeric( $desc_line_ht ) ) {
				$desc_line_ht = 'desktop:' . $desc_line_ht . 'px;';
			}

			$advanced_tabs_desc_id = 'advanced-tabs-desc-wrap-' . rand( 1000, 9999 );

			$advanced_tabs_desc_args = array(
				'target'      => '#' . $advanced_tabs_desc_id . ' .ult_tabcontent .ult_tab_min_contain  p', // set targeted element e.g. unique class/id etc.
				'media_sizes' => array(
					'font-size'   => $desc_font_size, // set 'css property' & 'ultimate_responsive' sizes. Here $title_responsive_font_size holds responsive font sizes from user input.
					'line-height' => $desc_line_ht
				),
			);

			$advanced_tabs_desc_data_list = get_ultimate_vc_responsive_media_css( $advanced_tabs_desc_args );


			if ( function_exists( 'get_ultimate_font_family' ) ) {

				$dhfont_family = get_ultimate_font_family( $desc_font_family );
				if ( $dhfont_family != '' ) {
					$contain_bg .= 'font-family:' . $dhfont_family . ';';
				}

			}
			if ( function_exists( 'get_ultimate_font_style' ) ) {
				if ( $desc_font_style != '' ) {
					$contain_bg .= get_ultimate_font_style( $desc_font_style );
				}
			}


			$ult_top = $icon_top_link = '';
			if ( $tab_style == 'Style_1' ) {
				$ult_top       = 'ult_top';
				$icon_top_link = 'icon_top_link';
			} else if ( $tab_style == 'Style_2' ) {

				$ult_top       = 'ult_top';
				$icon_top_link = '';
			}
			if ( $tab_style == 'Style_4' ) {
				$tab_style_no  .= 'Style_4';
				$ult_top       = 'ult_top';
				$icon_top_link = 'style_4_top';
			}
			if ( $tab_style == 'Style_5' ) {
				$tab_style_no  .= 'Style_5';
				$icon_top_link = '';

			}
			if ( $tab_style == 'Style_6' ) {
				$tab_style_no  .= 'Style_6';
				$icon_top_link = '';

			}
			if ( $tab_style == 'Style_3' ) {
				$ult_top       = 'ult_top';
				$icon_top_link = 'icon_top_link';
			}

			if ( $tab_nav_full_width ) {
				$tab_nav_full_width = 'st-adv-tabs-nav-full-width';
			}

			if ( $tab_nav_item_eq_width ) {
				$tab_nav_item_eq_width = 'st-adv-tabs-nav-eq-width';
			}

			if ( $active_tab_marker ) {
				$active_tab_marker = 'st-adv-tabs-disable-tab-marker';
			}

			if ( $enable_bg_color != '' ) {
				$contain_bg .= 'background-color:' . $enable_bg_color . ';';
			}
			if ( $container_border_style1 != '' ) {
				$container_border_style1 = str_replace( "|", " ", $container_border_style1 );
				//$contain_bg .='border-style:'.$container_border_style.';';
				//$contain_bg .='border-color:'.$container_color_border.';';
				//$contain_bg .='border-width:'.$cont_border_size.'px;';
				//$contain_bg .='border-top:none;';
				$contain_bg .= $container_border_style1;
			}
			if ( $tab_describe_color != '' ) {
				$contain_bg .= 'color:' . $tab_describe_color . ';';
			}
			$acord = '';
//echo $resp_style;
			$array_count = '';
			$array_count = sizeof( $tabarr );
			$newtab      = '';
			$newtab      .= '<ul id=' . esc_attr( $advanced_tabs_id ) . ' class="ult_tabmenu ' . esc_attr( $style ) . ' ' . esc_attr( $tab_style_no ) . ' ' . $tab_nav_full_width . ' ' . $active_tab_marker . ' ' . $tab_nav_item_eq_width . '" style="' . esc_attr( $tab_border ) . '">';
			$cnt         = 0;
//print_r($tabarr );

			$acord         .= '';
			$accontaint    = '';
			$ult_ac_border = '';
			foreach ( $tabarr as $key => $value ) {
				$cnt ++;


				$icon_position = $font_icons_position;
				//echo $disp_icon;
				if ( $disp_icon == 'Disables' ) {
					$icon_position = 'none';
				}
				$tab_icon_type            = $value["icon_type"];
				$tabicon                  = $value["icon"];
				$tabimg                   = $value["icon_img"];
				$tabbg                    = $value["subtab_bg_image"];
				$icon_color               = $icon_color;
				$icon_size                = $icon_size;
				$icon_bg_size             = $icon_bg_size;
				$icon_hover_color         = $icon_hover_color;
				$icon_border              = $icon_border;
				$icon_border_color_active = $icon_border_color_active;
				$icon_border_color_hover  = $icon_border_color_hover;
				$margin                   = $icon_margin;
				$tab_id                   = $value["tab_id"];
				$accontaint               = $value['content'];
				$accontaint               = wpb_js_remove_wpautop( $accontaint );
				$ul_sub_class             = $value['ul_sub_class'];
				/*---icon style---*/
				$icon_size;
				if ( $icon_size == '' ) {
					$icon_size = "15";
				}
				$tab_icon_style = '';
				$tab_icon_style .= 'color:' . $icon_color . ';';
				$tab_icon_style .= 'font-size:' . $icon_size . 'px;';
				if ( $icon_bg_size !== '' ) {
					$tab_icon_style .= 'height:' . $icon_bg_size . 'px;width:' . $icon_bg_size . 'px;line-height:' . $icon_bg_size . 'px;';
				}
				$tab_icon_style .= $margin;
				if ( $icon_border != '' ) {
					$icon_border_style = str_replace( "|", " ", $icon_border );
					$tab_icon_style    .= $icon_border_style;
				}
				$link_li_style = '';
				$bgcolor       = '';
				if ( $icon_border_color_hover !== '' || $icon_border_color_active !== '' ) {
					$hover_style = '';
					$hover_style .= '<style type="text/css">';
					if ( $icon_border_color_hover !== '' ) {
						$hover_style .= '#' . $advanced_tabs_desc_id . ' .ult_tab_li:hover .aio-icon{border-color:' . $icon_border_color_hover . ' !important}';
					}
					if ( $icon_border_color_active !== '' ) {
						$hover_style .= '#' . $advanced_tabs_desc_id . ' .ult_tab_li.current .aio-icon{border-color:' . $icon_border_color_active . ' !important}';
					}
					$hover_style  .= '</style>';
					$hover_output = "<script type=\"text/javascript\">jQuery(document).ready(function(){jQuery('head').append('" . $hover_style . "');});</script>";
				} else {
					$hover_style  = '';
					$hover_output = '';
				}
				if ( $tab_style != 'Style_2' ) {
					$link_li_style .= 'background-color:' . $tab_background_color . ';';
				} else {
					$bgcolor .= 'background-color:' . $tab_background_color . ';';

				}
				$style5bgcolor = '';
				if ( $tab_style == 'Style_5' || $tab_style == 'Style_6' ) {
					$style5bgcolor = 'border-color:' . $shadow_color . ';';
					$ult_top       = 'ult_top';
				}

				if ( $tab_style == 'Style_4' ) {
					$ult_top       = 'ult_top';
					$link_li_style .= '';
					$link_li_style .= 'border-color:' . $border_color . ';';
					$link_li_style .= 'border-width:' . $border_thickness . 'px;';
					$link_li_style .= 'border-style:solid;';

				}
				if ( $tab_style == 'Style_1' || $tab_style == 'Style_3' ) {

					$link_li_style .= '';
					$link_li_style .= 'border-color:' . $border_color . ';';
					$link_li_style .= 'border-width:' . $border_thickness . 'px;';
					$link_li_style .= 'border-style:solid;';

				}

				if ( $tabs_padding !== '' ) {
					$li_inner_padding = 'style="padding:' . $tabs_padding . 'px"';
				} else {
					$li_inner_padding = '';
				}

				/*---------------- for tabs border -----------------*/

				if ( $tab_style != 'Style_2' ) {
					if ( $cnt == $array_count ) {
						$link_li_style .= 'border-top-right-radius:' . $tabs_border_radius . 'px;';
					} else if ( $cnt == 1 ) {
						$link_li_style .= 'border-top-left-radius:' . $tabs_border_radius . 'px;';
					}

				} else {

					if ( $cnt == $array_count ) {
						$bgcolor .= 'border-top-right-radius:' . $tabs_border_radius . 'px;';
					} else if ( $cnt == 1 ) {
						$bgcolor .= 'border-top-left-radius:' . $tabs_border_radius . 'px;';
					}

				}

				/*------------ accordian border style --------------*/

				$ult_ac_border .= 'border-bottom-color:' . $border_color . ';';
				$ult_ac_border .= 'border-bottom-width:' . $border_thickness . 'px;';
				$ult_ac_border .= 'border-bottom-style:solid;';

				if ( isset( $value['title'] ) ) {
					$subtab_bg_image = wp_get_attachment_image_src( $tabbg, 'full' );
					if ( $subtab_bg_image ) {
						$bg_link = $subtab_bg_image[0];
						$bg      = '<div class="st-adv-tab-bg" style="background-image: url(' . $bg_link . ')"></div>';
					} else {
						$bg = ' ';
					}

					//echo $icon_position;
					if ( $icon_position == 'Right' ) {
						$icon_position = 'right';
						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . ' " data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a ' . esc_attr( $css_class ) . '">
					   <span class="ult_tab_main  ' . esc_attr( $resp_style ) . ' " ' . $li_inner_padding . '>
					    <span class="ult_tab_section">
					  		<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
						   	<span class="aio-icon none ult_tab_icon' . esc_attr( $icon_position ) . '" style="' . esc_attr( $tab_icon_style ) . '">
						   	<img class="img-icon" alt="' . $alt . '" src="' . $img . '"/>
						   </span>
						</span>
					   </span>

					</a>
					</li>';
						} else {
							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . ' " data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a ' . esc_attr( $css_class ) . '">
					   <span class="ult_tab_main  ' . esc_attr( $resp_style ) . ' " ' . $li_inner_padding . '>
					    <span class="ult_tab_section">
					  		<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
						   	<span class="aio-icon none ult_tab_icon' . esc_attr( $icon_position ) . '" style="' . esc_attr( $tab_icon_style ) . '">
						   	<i class=" ' . esc_attr( $tabicon ) . ' ult_tab_icon"  ></i>
						   </span>
						</span>
					   </span>

					</a>
					</li>';
						}

						/*-------------------accordion right icon------------------*/

						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
        	<a class="ult-tabto-actitle withBorder ult_a" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
        		<i class="accordion-icon"></i>
        			<span class="ult_tab_main ult_ac_main' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
					   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
					</span>
					   <div class="aio-icon none " style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
					   <img class="ult_tab_icon" alt="' . $alt . '" src="' . $img . '"/>
					   </div>
					</a></dt>
            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
            		<div class="st-adv-tab-bg" style="background-image: url(' . $bg_link . ')"></div>
			            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
			               ' . $accontaint . '
			            </div>
        	</dd>';
						} else {
							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
        	<a class="ult-tabto-actitle withBorder ult_a" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
        		<i class="accordion-icon"></i>
        			<span class="ult_tab_main ult_ac_main' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
					   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
					</span>
					   <div class="aio-icon none " style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
					   <i class="  ' . esc_attr( $tabicon ) . ' ult_tab_icon"  ></i>
					   </div>
					</a></dt>
            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
            		<div class="st-adv-tab-bg" style="background-image: url(' . $bg_link . ')"></div>
			            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
			               ' . $accontaint . '
			            </div>
        	</dd>';
						}

					} else if ( $icon_position == 'Left' ) {
						$icon_position = 'left';
						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a  ' . esc_attr( $css_class ) . '">
					     <span class="ult_tab_main ' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
					      <span class="ult_tab_section">
						   <span class="aio-icon none ult_tab_icon' . esc_attr( $icon_position ) . '" style="' . esc_attr( $tab_icon_style ) . '">
						   <img class="img-icon" alt="' . $alt . '" src="' . $img . '"/>
						   </span>
						   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
						    </span >
						</span>
					</a>
					</li>';
						} else {
							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a  ' . esc_attr( $css_class ) . '">
					     <span class="ult_tab_main ' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
					      <span class="ult_tab_section">
						   <span class="aio-icon none ult_tab_icon' . esc_attr( $icon_position ) . '" style="' . esc_attr( $tab_icon_style ) . '">
						   <i class="  ' . esc_attr( $tabicon ) . ' ult_tab_icon"  ></i>
						   </span>
						   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
						    </span >
						</span>
					</a>
					</li>';
						}

						/*-------------------accordion left icon------------------*/

						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
        	<a class="ult-tabto-actitle withBorder ult_a"  id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
        		<i class="accordion-icon"></i>
        			<span class="ult_tab_main ult_ac_main' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
					   <div class="aio-icon none " style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
					   <img class="ult_tab_icon" alt="' . $alt . '" src="' . $img . '"/>
					   </div>
					<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
					</span></a></dt>
            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
            		' . $bg . '
			            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
			               ' . $accontaint . '
			            </div>
        	</dd>';
						} else {
							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
        	<a class="ult-tabto-actitle withBorder ult_a"  id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
        		<i class="accordion-icon"></i>
        			<span class="ult_tab_main ult_ac_main' . esc_attr( $resp_style ) . '">
					   <div class="aio-icon none " style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
					   <i class="  ' . esc_attr( $tabicon ) . ' ult_tab_icon"  ></i>
					   </div>
					<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
					</span></a></dt>
            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
            		<div class="st-adv-tab-bg" style="background-image: url(' . $bg_link . ')"></div>
			            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
			               ' . $accontaint . '
			            </div>
        	</dd>';
						}
					} else if ( $icon_position == 'Top' ) {
						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '"  style="color:' . $tab_title_color . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a ' . esc_attr( $icon_top_link ) . ' ' . esc_attr( $css_class ) . '">
					    <span class="ult_tab_main ' . esc_attr( $ult_top ) . ' ' . esc_attr( $resp_style ) . ' " ' . $li_inner_padding . '>
					    <span class="ult_tab_section">
					   <span class="aio-icon none icon-top ult_tab_icon' . esc_attr( $icon_position ) . '"  style="' . esc_attr( $tab_icon_style ) . '">
					   <img class="img-icon" alt="' . $alt . '" src="' . $img . '"/>
					   </span>
					   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
					   </span>
						</span>
					</a>
					</li>';
						} else {
							$newtab .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '" id="' . esc_attr( $tab_id ) . '"  style="color:' . $tab_title_color . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . '" class="ult_a ' . esc_attr( $icon_top_link ) . ' ' . esc_attr( $css_class ) . '">
					    <span class="ult_tab_main ' . esc_attr( $ult_top ) . ' ' . esc_attr( $resp_style ) . ' " ' . $li_inner_padding . '>
					    <span class="ult_tab_section">
					   <span class="aio-icon none icon-top ult_tab_icon' . esc_attr( $icon_position ) . '"  style="' . esc_attr( $tab_icon_style ) . '">
					   <i class="  ' . esc_attr( $tabicon ) . ' ult_tab_icon" ></i>
					   </span>
					   <span ' . $advanced_tabs_data_list . ' class="ult-span-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . '">' . $value['title'] . '</span>
					   </span>
						</span>
					</a>
					</li>';
						}

						/*-------------------accordion top icon------------------*/

						if ( $tab_icon_type == 'custom' ) {

							$img = apply_filters( 'ult_get_img_single', $tabimg, 'url' );
							$alt = apply_filters( 'ult_get_img_single', $tabimg, 'alt' );

							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
	        	<a class="ult-tabto-actitle withBorder ult_a" id="' . esc_attr( $tab_id ) . '"  style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
	        		<i class="accordion-icon"></i>
	        			<span class="ult_tab_main ult_ac_main ult_top ' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
						   <span class="aio-icon none icon-top" style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
						   <img class="ult_tab_icon" alt="' . $alt . '" src="' . $img . '"/>
						   </span>
						<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
						</span></a></dt>
	            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
				            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
				               ' . $accontaint . '
				            </div>
	        	</dd>';
						} else {
							$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
	        	<a class="ult-tabto-actitle withBorder ult_a" id="' . esc_attr( $tab_id ) . '"  style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
	        		<i class="accordion-icon"></i>
	        			<span class="ult_tab_main ult_ac_main ult_top ' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>
						   <span class="aio-icon none icon-top" style="' . esc_attr( $tab_icon_style ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '">
						   <i class="  ' . esc_attr( $tabicon ) . ' ult_tab_icon"  ></i>
						   </span>
						<span ' . $advanced_tabs_data_list . ' class="ult-span-text ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
						</span></a></dt>
	            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
				            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
				               ' . $accontaint . '
				            </div>
	        	</dd>';
						}

					} else {
						$icon_position = 'none';
						$newtab        .= '<li class="ult_tab_li ' . esc_attr( $ult_style ) . ' ' . esc_attr( $ul_sub_class ) . '" data-iconcolor="' . esc_attr( $icon_color ) . '" data-iconhover="' . esc_attr( $icon_hover_color ) . '" style="' . esc_attr( $link_li_style ) . '">
					<a href="#' . esc_attr( $tab_id ) . '"  id="' . esc_attr( $tab_id ) . '"  style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $bgcolor ) . ';' . esc_attr( $style5bgcolor ) . ' ' . esc_attr( $tab_css ) . ' " class="ult_a ' . esc_attr( $ult_style ) . ' ' . esc_attr( $css_class ) . '">
					     <span class="ult_tab_main ' . esc_attr( $resp_style ) . ' " ' . $li_inner_padding . '>
					 		 <span class="ult_tab_section">
					   			<span ' . $advanced_tabs_data_list . ' class="ult-span-text no_icon ult_tab_display_text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';">' . $value['title'] . '</span>
					   		</span>
						</span>
					</a>
					</li>';

						/*-------------------accordion without icon------------------*/

						$acord .= '<dt class="' . esc_attr( $ul_sub_class ) . '">
	        	<a class="ult-tabto-actitle withBorder ult_a " id="' . esc_attr( $tab_id ) . '" style="color:' . esc_attr( $tab_title_color ) . ';' . esc_attr( $style5bgcolor ) . ';background-color:' . esc_attr( $tab_background_color ) . ';' . esc_attr( $ult_ac_border ) . '" href="#' . esc_attr( $tab_id ) . '">
	        		<i class="accordion-icon"></i>
	        			<span class="ult_tab_main ult_ac_main ult_noacordicn' . esc_attr( $resp_style ) . '" ' . $li_inner_padding . '>

						<span ' . $advanced_tabs_data_list . ' class="ult-span-text no_icon ult_acordian-text ult-responsive" style="' . esc_attr( $tabs_nav_style ) . ';color:inherit " >' . $value['title'] . '</span>
						</span></a></dt>
	            		<dd class="ult-tabto-accordionItem ult-tabto-accolapsed">
				            <div class="ult-tabto-acontent" style="' . esc_attr( $contain_bg ) . '">
				               ' . $accontaint . '
				            </div>
	        			</dd>';

					}

				}
			}
			$newtab .= '</ul>';

			$newtabcontain  = '';
			$newtabcontain  .= '<div class="ult_tab_min_contain">';
			$newtabcontain  .= '<div class="ult_tabitemname" style="color:inherit">';
			$newtabcontain  .= wpb_js_remove_wpautop( $content );
			$newtabcontain  .= '</div>';
			$newtabcontain  .= '</div>';
			$op             = '';
			$op             .= '<div id="' . esc_attr( $advanced_tabs_desc_id ) . '" class="ult_tabs ' . $tab_style . ' ' . esc_attr( $el_class ) . '" style="' . esc_attr( $container_style ) . ' ' . esc_attr( $wrapper_margin ) . '" data-tabsstyle="' . esc_attr( $style ) . '"
 data-titlebg="' . esc_attr( $tab_background_color ) . '" data-titlecolor="' . esc_attr( $tab_title_color ) . '" data-fullheight="' . esc_attr( $tab_max ) . '"
 data-titlehoverbg="' . esc_attr( $tab_hover_background_color ) . '" data-titlehovercolor="' . esc_attr( $tab_hover_title_color ) . '"
 data-rotatetabs="' . esc_attr( $interval ) . '" data-responsivemode="' . esc_attr( $resp_style ) . '" data-animation="' . esc_attr( $tab_animation ) . '"
data-activetitle="' . esc_attr( $acttab_title ) . '" data-activeicon="' . esc_attr( $act_icon_color ) . '" data-activebg="' . esc_attr( $acttab_background ) . '"  data-respmode="' . esc_attr( $resp_type ) . '" data-respwidth="' . esc_attr( $resp_width ) . '" data-scroll = "' . esc_attr( $smooth_scroll ) . '" data-activeindex="' . esc_attr( $tabs_active_index ) . '">';
			$op             .= $newtab;
			$op             .= '<div ' . $advanced_tabs_desc_data_list . 'class="ult_tabcontent ult-responsive ' . esc_attr( $style ) . '" style="' . esc_attr( $contain_bg ) . '">';
			$tabanimatclass = "";
			if ( $tab_animation == 'Slide-Zoom' ) {

				$tabanimatclass = "tabanimate";
			}
			$op .= '<div class="ult_tab_min_contain ' . esc_attr( $tabanimatclass ) . '" >';
			$op .= wpb_js_remove_wpautop( $content );
			$op .= '</div>';
			$op .= '</div>';
			$op .= '</div>';
			$op .= $hover_output;
			ob_start();
//return $op;
			echo $op;

			/*---------------- for acordian -----------------*/
			$actab = '';
			$actab .= '<div class="ult_acord ' . esc_attr( $advanced_tabs_desc_id ) . '">
   <div class="ult-tabto-accordion " style="width:;"
    data-titlecolor="' . esc_attr( $tab_title_color ) . '"  data-titlebg="' . esc_attr( $tab_background_color ) . '"
     data-titlehoverbg="' . esc_attr( $tab_hover_background_color ) . '" data-titlehovercolor="' . esc_attr( $tab_hover_title_color ) . '" data-animation="' . esc_attr( $tab_animation ) . '"
     data-activetitle="' . esc_attr( $acttab_title ) . '" data-activeicon="' . esc_attr( $act_icon_color ) . '" data-activebg="' . esc_attr( $acttab_background ) . '" data-scroll = "' . esc_attr( $smooth_scroll ) . '" data-activeindex="' . esc_attr( $tabs_active_index ) . '" >
     <dl>';

			$actab .= $acord;
			$actab .= '
    	</dl>
    <!--<div class="extraborder" style="background-color:' . esc_attr( $tab_hover_background_color ) . '"></div>-->
</div>

</div>';

//return $actab;
			echo $actab;

			return ob_get_clean();

		}


		function ult_tab_init() {

			$tab_id_1 = time() . '-1-' . rand( 0, 100 );
			$tab_id_2 = time() . '-2-' . rand( 0, 100 );

			$settings = array(
				'name'              => __( 'Advanced Tabs' ),
				'base'              => 'ult_tab_element',
				"category"          => __( "Ultimate VC Addons", "adamas-vc-shortcodes" ),
				"description"       => __( "Create nice looking tabs.", "adamas-vc-shortcodes" ),
				"class"             => "ult_tab_eleicon",
				//'show_settings_on_create' => false,
				'is_container'      => true,
				'weight'            => - 5,
				'html_template'     => UAVC_DIR . 'vc_templates/ult_tab_element.php',
				'admin_enqueue_css' => preg_replace( '/\s/', '%20', UAVC_URL . 'admin/vc_extend/css/sub-tab.css' ),
				'js_view'           => 'UltimateTabView',
				// JS View name for backend. Can be used to override or add some logic for shortcodes in backend (cloning/rendering/deleting/editing).
				'icon'              => 'icon-wpb-ui-tab-content ult_tab_eleicon',
				'params'            => array(

					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Style" ),
						"param_name" => "tab_style",
						"value"      => array( 'Style 1' => 'Style_1', 'Style 2' => 'Style_2', 'Style 3' => 'Style_3', 'Style 4' => 'Style_4', 'Style 5' => 'Style_5', 'Style 6' => 'Style_6', 'Theme Style' => 'Adamas_Style', 'Theme Style 2' => 'Adamas_Style_2' ),
						"group"      => "General ",
					),

					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Animation" ),
						"param_name" => "tab_animation",
						"value"      => array(
							'Vertical Slide '  => '',
							'Horizontal Slide' => 'Slide-Horizontal',
							'Slide-Zoom'       => 'Slide-Zoom',
							'Fade'             => 'Fade',
							'Scale'            => 'Scale',
							'None'             => 'None'
						),

						"group" => "General ",

					),

					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( " Auto Rotate Tabs" ),
						"param_name" => "auto_rotate",
						"value"      => array( "Disable" => "Disables", "Enable" => "Enable" ),
						"group"      => "General ",
					),

					array(
						'type'       => 'number',
						'heading'    => __( 'Auto Rotate Interval', 'adamas-vc-shortcodes' ),
						'param_name' => 'interval',
						//'std' => 2,
						'value'      => '',
						"suffix"     => "seconds",
						"dependency" => array( "element" => "auto_rotate", "value" => array( "Enable" ) ),
						"group"      => "General ",

					),
					array(
						"type"        => "checkbox",
						"class"       => "",
						"heading"     => __( "Tabs navigation full width", "adamas-vc-shortcodes" ),
						"param_name"  => "tab_nav_full_width",
						"value"       => array( __( "Yes", "adamas-vc-shortcodes" ) => "yes" ),
						"description" => __( "Check this if you want to set tabs navigation to full width.", "adamas-vc-shortcodes" ),
						"dependency"  => array( "element" => "tab_style", "value" => array( "Adamas_Style" ) ),
						"group"       => "General ",
					),
					array(
						"type"        => "checkbox",
						"class"       => "",
						"heading"     => __( "Disable side marker on active tab", "adamas-vc-shortcodes" ),
						"param_name"  => "active_tab_marker",
						"value"       => array( __( "Yes", "adamas-vc-shortcodes" ) => "yes" ),
						"description" => __( "Check this if you want to turn off side border marker on active tab.", "adamas-vc-shortcodes" ),
						"dependency"  => array( "element" => "tab_style", "value" => array( "Adamas_Style" ) ),
						"group"       => "General ",
					),
					array(
						"type"        => "checkbox",
						"class"       => "",
						"heading"     => __( "Tabs navigation items equal width", "adamas-vc-shortcodes" ),
						"param_name"  => "tab_nav_item_eq_width",
						"description" => __( "Check this if you want to set tabs navigation items width to equal.", "adamas-vc-shortcodes" ),
						"dependency"  => array( "element" => "tab_nav_full_width", "value" => array( "yes" ) ),
						"group"       => "General ",
					),
					array(
						'type'        => 'number',
						'heading'     => __( 'Tab Element Width' ),
						'value'       => '',
						"min"         => 300,
						"suffix"      => "px",
						'param_name'  => 'container_width',
						'description' => __( 'Adjust width of your tab section. Keep empty for full width.' ),
						"group"       => "General ",
					),
					array(
						"type"        => "ult_switch",
						"class"       => "",
						//"heading" => __("Want To show button in responsive mode", "adamas-vc-shortcodes"),
						"param_name"  => "tab_max",
						// "admin_label" => true,
						"value"       => "off",
						"default_set" => true,
						"options"     => array(
							"on" => array(
								"label" => __( "Apply Max height to container?", "adamas-vc-shortcodes" ),
								"off"   => __( "No", "adamas-vc-shortcodes" ),
								"on"    => __( "Yes", "adamas-vc-shortcodes" ),
							),
						),
						"description" => __( "Apply Max height to container?", 'adamas-vc-shortcodes' ),
						"group"       => "General ",
					),
					array(
						'type'        => 'textfield',
						'heading'     => __( 'Extra Class Name', 'adamas-vc-shortcodes' ),
						'param_name'  => 'el_class',
						'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' ),
						"group"       => "General ",
					),


					/*---------tab----------------*/
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Tabs List Background Color" ),
						"param_name" => "tabs_list_color",
						"value"      => "",
						"group"      => "Tab",
						"dependency" => array( "element" => "tab_style", "value" => array( "Adamas_Style_2" ) ),
					),
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Tab Title Color" ),
						"param_name" => "tab_title_color",
						"value"      => "",
						"group"      => "Tab",

					),

					array(
						"type"             => "colorpicker",
						"heading"          => __( " Tab Background Color" ),
						"param_name"       => "tab_background_color",
						"value"            => "",
						"group"            => "Tab",
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),


					array(
						"type"       => "colorpicker",
						"heading"    => __( " Tab Hover Title Color" ),
						"param_name" => "tab_hover_title_color",
						"value"      => "",
						"group"      => "Tab",

					),
					array(
						"type"             => "colorpicker",
						"heading"          => __( " Tab Hover Background Color" ),
						"param_name"       => "tab_hover_background_color",
						"value"            => "",
						"group"            => "Tab",
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),

					array(
						"type"       => "colorpicker",
						"heading"    => __( "Tab Active Title Color" ),
						"param_name" => "acttab_title",
						"value"      => "",
						"group"      => "Tab",
					),

					array(
						"type"             => "colorpicker",
						"heading"          => __( "Tab Active Background Color" ),
						"param_name"       => "acttab_background",
						"value"            => "",
						"group"            => "Tab",
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),
					array(
						"type"             => "ultimate_spacing",
						"heading"          => "Tab Padding",
						"param_name"       => "tab_css",
						"mode"             => "padding",                    //  margin/padding
						"unit"             => "px",                        //  [required] px,em,%,all     Default all
						"positions"        => array(                   //  Also set 'defaults'
							"Top"    => "",
							"Right"  => "",
							"Bottom" => "",
							"Left"   => "",
						),
						"group"            => "Tab",
						"description"      => __( "Adjust inside spacing of tabs.", "adamas-vc-shortcodes" ),
						"dependency"       => array( "element" => "tab_style", "value" => array( "Style_4", "Style_1", "Style_3", "Style_5", "Style_6" ) ),
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),


					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Tab Border" ),
						"param_name" => "tab_bottom_border",
						"value"      => array( 'Disable' => 'Disable', 'Enable' => 'Enable' ),
						"dependency" => array( "element" => "tab_style", "value" => array( "Style_1", "Style_3", "Style_4" ) ),
						"group"      => "Tab",
					),

					array(
						"type"       => "colorpicker",
						"heading"    => __( "Tab Border Color" ),
						"param_name" => "border_color",
						"value"      => "",
						"dependency" => array( "element" => "tab_bottom_border", "value" => array( "Enable" ) ),
						"group"      => "Tab",
					),

					array(
						'type'       => 'number',
						"class"      => "",
						'heading'    => __( 'Tab Border Thickness' ),
						'param_name' => 'border_thickness',
						"dependency" => array( "element" => "tab_bottom_border", "value" => array( "Enable" ) ),
						'min'        => '1',
						'value'      => '',
						'suffix'     => 'px',
						"group"      => "Tab",
					),
					array(
						"type"             => "number",
						"class"            => "",
						"heading"          => __( "Tab Border Radius", "adamas-vc-shortcodes" ),
						"param_name"       => "tabs_border_radius",
						"value"            => "",
						"min"              => 1,
						"max"              => 100,
						"suffix"           => "px",
						"description"      => __( "This border will assign to border-top-left and border-top-right for first and last tab element . As you increase the value, the shape convert in circle slowly. (e.g 100 pixels).", "adamas-vc-shortcodes" ),
						"group"            => "Tab",
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),
					array(
						"type"        => "number",
						"class"       => "",
						"heading"     => __( "Tab Padding", "adamas-vc-shortcodes" ),
						"param_name"  => "tabs_padding",
						"value"       => "",
						"min"         => 1,
						"max"         => 100,
						"suffix"      => "px",
						"description" => __( "Assign padding of tabs navigation elements.", "adamas-vc-shortcodes" ),
						"group"       => "Tab",
					),
					array(
						"type"             => "number",
						"class"            => "",
						"heading"          => __( "Initial Active Tab", "adamas-vc-shortcodes" ),
						"param_name"       => "tabs_active_index",
						"value"            => "1",
						"min"              => 1,
						"max"              => 100,
						"suffix"           => "",
						"description"      => __( 'Enter active tab number (Note: to have all tabs closed on initial load enter non-existing number).', "adamas-vc-shortcodes" ),
						"group"            => "Tab",
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Tab Shaddow Color" ),
						"param_name" => "shadow_color",
						"value"      => "",
						"dependency" => array( "element" => "tab_style", "value" => array( "Style_5", "Style_6" ) ),
						"group"      => "Tab",

					),
					/*---------icon----------------*/
					array(
						"type"        => "dropdown",
						"class"       => "",
						"heading"     => __( "Display Icon" ),
						"param_name"  => "disp_icon",
						"value"       => array( "Enable" => "Enable", "Disable" => "Disables" ),
						"group"       => "Icon ",
						"description" => __( "Display icon with tab title.", "adamas-vc-shortcodes" ),
					),

					array(
						"type"             => "ult_param_heading",
						"param_name"       => "icon_text_setting",
						"text"             => __( "Please choose icon from Subtab settings ", "adamas-vc-shortcodes" ),
						"value"            => "",
						"class"            => "",
						"group"            => "Icon ",
						'edit_field_class' => 'ult-param-heading-wrapper  vc_column vc_col-sm-12 ult_tabicon_notice',
					),
					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Icon Position" ),
						"param_name" => "font_icons_position",
						"value"      => array(//'None'=>'None',
							'Right' => 'Right',
							'Left'  => 'Left',
							'Top'   => 'Top',
						),
						"group"      => "Icon ",
						"dependency" => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
					),
					array(
						"type"             => "number",
						'heading'          => __( 'Icon Size', 'smile' ),
						'param_name'       => 'icon_size',
						"value"            => "",
						"min"              => 15,
						"max"              => 72,
						"suffix"           => "px",
						"group"            => "Icon ",
						"dependency"       => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Icon Color", "smile" ),
						"param_name" => "icon_color",
						"value"      => "",
						"group"      => "Icon ",
						"dependency" => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
					),
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Icon Hover Color", "smile" ),
						"param_name" => "icon_hover_color",
						"value"      => "",
						"group"      => "Icon ",
						"dependency" => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
					),
					array(
						"type"             => "colorpicker",
						"heading"          => __( "Icon Active Color" ),
						"param_name"       => "act_icon_color",
						"value"            => "",
						"group"            => "Icon ",
						"dependency"       => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					),
					array(
						"type"        => "ultimate_spacing",
						"heading"     => " Icon Margin ",
						"param_name"  => "icon_margin",
						"mode"        => "margin",                    //  margin/padding
						"unit"        => "px",                        //  [required] px,em,%,all     Default all
						"positions"   => array(                   //  Also set 'defaults'
							"Top"    => "",
							"Right"  => "",
							"Bottom" => "",
							"Left"   => "",
						),
						"group"       => "Icon ",
						"dependency"  => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"description" => __( "Adjust spacing of icon.", "adamas-vc-shortcodes" ),
					),
					array(
						"type"        => "ultimate_border",
						"heading"     => "Icon border",
						"param_name"  => "icon_border",
						"group"       => "Icon ",
						"dependency"  => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"description" => __( "Adjust icon border color.", "adamas-vc-shortcodes" ),
					),
					array(
						"type"        => "colorpicker",
						"heading"     => "Icon border color in active tab",
						"param_name"  => "icon_border_color_active",
						"group"       => "Icon ",
						"dependency"  => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"description" => __( "Adjust icon border color in active tab.", "adamas-vc-shortcodes" ),
					),
					array(
						"type"        => "colorpicker",
						"heading"     => "Icon border color on hover",
						"param_name"  => "icon_border_color_hover",
						"group"       => "Icon ",
						"dependency"  => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"description" => __( "Adjust icon border color on hover.", "adamas-vc-shortcodes" ),
					),
					array(
						"type"        => "number",
						"heading"     => "Icon background size",
						"param_name"  => "icon_bg_size",
						"group"       => "Icon ",
						"dependency"  => array( "element" => "disp_icon", "value" => array( "Enable" ) ),
						"description" => __( "Adjust icon inner spacing.", "adamas-vc-shortcodes" ),
					),


					/*--------------container-----------*/

					array(
						"type"       => "colorpicker",
						"heading"    => __( "Container Text Color" ),
						"param_name" => "tab_describe_color",
						"value"      => "",
						"group"      => "Container ",
					),
					array(
						"type"       => "colorpicker",
						"heading"    => __( "Container Background Color" ),
						"param_name" => "enable_bg_color",
						"value"      => "",
						"group"      => "Container ",

					),
					array(
						"type"         => "ultimate_border",
						"heading"      => __( "Container Border", "adamas-vc-shortcodes" ),
						"param_name"   => "container_border_style1",
						"unit"         => "px",                        //  [required] px,em,%,all     Default all
						"positions"    => array(
							__( "Top", "adamas-vc-shortcodes" )    => "",
							__( "Right", "adamas-vc-shortcodes" )  => "",
							__( "Bottom", "adamas-vc-shortcodes" ) => "",
							__( "Left", "adamas-vc-shortcodes" )   => ""
						),
						//"enable_radius" => false,                   //  Enable border-radius. default true
						"radius"       => array(
							__( "Top Left", "adamas-vc-shortcodes" )     => "",                // use 'Top Left'
							__( "Top Right", "adamas-vc-shortcodes" )    => "",                  // use 'Top Right'
							__( "Bottom Right", "adamas-vc-shortcodes" ) => "3",                // use 'Bottom Right'
							__( "Bottom Left", "adamas-vc-shortcodes" )  => "3"                   // use 'Bottom Left'
						),
						"label_color"  => __( "Container Border Color", "adamas-vc-shortcodes" ),       //  label for 'border color'   default 'Border Color'
						"label_radius" => __( "Container Border Radius", "adamas-vc-shortcodes" ),        //  label for 'radius'  default 'Border Redius'
						//"label_border"  => "Border Style",       //  label for 'style'   default 'Border Style'
						"group"        => "Container ",
					),

					/*-------------design-------------*/
					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Responsive Mode for Tabs " ),
						"param_name" => "resp_type",
						"value"      => array(
							'Tabs'      => 'Tabs',
							'Accordion' => 'Accordion',
						),

						"group"       => "Responsive",
						"description" => __( "Display normal tab or convert them into accordion on responsive devices.", "adamas-vc-shortcodes" ),
					),

					array(
						"type"        => "number",
						"class"       => "",
						"heading"     => __( "Responsive Width", "adamas-vc-shortcodes" ),
						"param_name"  => "resp_width",
						"value"       => "",
						"min"         => 300,
						"max"         => 1200,
						"suffix"      => "px",
						"description" => __( "Enable accordion below this width.", "adamas-vc-shortcodes" ),
						"dependency"  => array( "element" => "resp_type", "value" => array( "Accordion" ) ),
						"group"       => "Responsive",

					),
					array(
						"type"        => "ult_switch",
						"class"       => "",
						//"heading" => __("Want To show button in responsive mode", "adamas-vc-shortcodes"),
						"param_name"  => "smooth_scroll",
						// "admin_label" => true,
						"value"       => "on",
						"default_set" => true,
						"options"     => array(
							"on" => array(
								"label" => __( "Scroll to Top of Container", "adamas-vc-shortcodes" ),
								"off"   => __( "No", "adamas-vc-shortcodes" ),
								"on"    => __( "Yes", "adamas-vc-shortcodes" ),
							),
						),
						"description" => __( "If enable, tab will adjust on viewport on click.", "adamas-vc-shortcodes" ),
						"dependency"  => array( "element" => "resp_type", "value" => array( "Accordion" ) ),
						"group"       => "Responsive",
					),
					array(
						"type"       => "dropdown",
						"class"      => "",
						"heading"    => __( "Responsive Mode Visibility " ),
						"param_name" => "resp_style",
						"value"      => array(
							'Both'  => 'Both',
							'Icon'  => 'Icon',
							'Title' => 'Title',
						),

						"group"       => "Responsive",
						"dependency"  => array( "element" => "resp_type", "value" => array( "Tabs" ) ),
						"description" => __( "Choose what you want to display on responsive devices.", "adamas-vc-shortcodes" ),
					),


					/*-----------typography------------*/

					array(
						"type"       => "text",
						"heading"    => __( "<h2>Title Settings</h2>" ),
						"param_name" => "main_title_typograpy",
						"group"      => "Typography",
					),

					array(
						"type"        => "ultimate_google_fonts",
						"heading"     => __( "Title Font Family", "imedica" ),
						"param_name"  => "main_heading_font_family",
						"description" => __( "Select the font of your choice. You can <a target='_blank' href='" . admin_url( 'admin.php?page=bsf-google-font-manager' ) . "'>add new in the collection here</a>.", "imedica" ),
						"group"       => "Typography",
					),

					array(
						"type"       => "ultimate_google_fonts_style",
						"heading"    => __( "Font Style", "imedica" ),
						"param_name" => "title_font_style",
						"group"      => "Typography",
					),


					// array(
					// 	"type" => "number",
					// 	"param_name" => "title_font_size",
					// 	"heading" => " Font size",
					// 	"value" => "",
					// 	"suffix" => "px",
					// 	"group" => "Typography"
					// 	),
					// array(
					// 	"type" => "number",
					// 	"param_name" => "title_line_ht",
					// 	"heading" => " Line Height",
					// 	"value" => "",
					// 	"suffix" => "px",
					// 	"group" => "Typography",
					// 	"edit_field_class" => "vc_col-sm-12 vc_column ult_space_border",
					// 	),

					array(
						"type"       => "ultimate_responsive",
						"class"      => "",
						"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
						"param_name" => "title_font_size",
						"unit"       => "px",
						"media"      => array(
							"Desktop"          => '',
							"Tablet"           => '',
							"Tablet Portrait"  => '',
							"Mobile Landscape" => '',
							"Mobile"           => '',
						),
						"group"      => "Typography",
					),
					array(
						"type"       => "ultimate_responsive",
						"class"      => "",
						"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
						"param_name" => "title_line_ht",
						"unit"       => "px",
						"media"      => array(
							"Desktop"          => '',
							"Tablet"           => '',
							"Tablet Portrait"  => '',
							"Mobile Landscape" => '',
							"Mobile"           => '',
						),
						"group"      => "Typography",
					),

					array(
						"type"       => "text",
						"heading"    => __( "<h2>Container Description </h2>" ),
						"param_name" => "main_desc_typograpy",
						"group"      => "Typography",
					),

					array(
						"type"        => "ultimate_google_fonts",
						"heading"     => __( " Font Family", "smile" ),
						"param_name"  => "desc_font_family",
						"description" => __( "Select the font of your choice. You can <a target='_blank' href='" . admin_url( 'admin.php?page=bsf-google-font-manager' ) . "'>add new in the collection here</a>.", "smile" ),
						"group"       => "Typography",
					),

					array(
						"type"       => "ultimate_google_fonts_style",
						"heading"    => __( "Font Style", "imedica" ),
						"param_name" => "desc_font_style",
						"group"      => "Typography",
					),
					// array(
					// 	"type" => "number",
					// 	"param_name" => "desc_font_size",
					// 	"heading" => " Font size",
					// 	"value" => "",
					// 	"suffix" => "px",
					// 	"group" => "Typography"
					// 	),

					// array(
					// 	"type" => "number",
					// 	"param_name" => "desc_line_ht",
					// 	"heading" => " Line Height",
					// 	"value" => "",
					// 	"suffix" => "px",
					// 	"group" => "Typography",
					// 	),
					array(
						"type"       => "ultimate_responsive",
						"class"      => "",
						"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
						"param_name" => "desc_font_size",
						"unit"       => "px",
						"media"      => array(
							"Desktop"          => '',
							"Tablet"           => '',
							"Tablet Portrait"  => '',
							"Mobile Landscape" => '',
							"Mobile"           => '',
						),
						"group"      => "Typography",
					),
					array(
						"type"       => "ultimate_responsive",
						"class"      => "",
						"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
						"param_name" => "desc_line_ht",
						"unit"       => "px",
						"media"      => array(
							"Desktop"          => '',
							"Tablet"           => '',
							"Tablet Portrait"  => '',
							"Mobile Landscape" => '',
							"Mobile"           => '',
						),
						"group"      => "Typography",
					),
					array(
						"type"        => "ultimate_spacing",
						"heading"     => " Wrapper Margin ",
						"param_name"  => "wrapper_margin",
						"mode"        => "margin",                    //  margin/padding
						"unit"        => "px",                        //  [required] px,em,%,all     Default all
						"positions"   => array(                   //  Also set 'defaults'
							"Top"    => "",
							"Right"  => "",
							"Bottom" => "",
							"Left"   => "",
						),
						'group'       => __( 'Design ', 'adamas-vc-shortcodes' ),
						"description" => __( "Add or remove margin for wrapper.", "adamas-vc-shortcodes" ),
					),

					/*----------end----------*/
				),
				'custom_markup'     => '<div class="wpb_tabs_holder wpb_holder vc_container_for_children">
									<ul class="tabs_controls">
									</ul>
									%content%
									</div>',

				'default_content' => '[single_tab title="' . __( 'Tab 1', 'adamas-vc-shortcodes' ) . '" tab_id="' . $tab_id_1 . ' ][/single_tab]
					  [single_tab title="' . __( 'Tab 2', 'adamas-vc-shortcodes' ) . '" tab_id="' . $tab_id_2 . ' ][/single_tab]
									',
			);
			if ( function_exists( 'vc_map' ) ) {
				vc_map( $settings );
			}


			/* ---for single tabs element-------------*/
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'                      => __( 'SubTab', 'adamas-vc-shortcodes' ),
					'base'                      => 'single_tab',
					"icon"                      => "ult_tab_eleicon",
					"class"                     => "ult_tab_eleicon",
					'allowed_container_element' => 'vc_row',
					'is_container'              => true,
					'content_element'           => true,
					"as_child"                  => array( 'only' => 'ult_tab_element' ),
					'html_template'             => UAVC_DIR . 'vc_templates/single_tab.php',
					//'admin_enqueue_js'  => preg_replace( '/\s/', '%20', plugins_url( 'vc_extend/js/single_element_js.js', __FILE__ ) ),
					'js_view'                   => 'UltimateSubTabView',
					'params'                    => array(

						array(
							'type'       => 'textfield',
							'heading'    => __( 'Title', 'adamas-vc-shortcodes' ),
							'param_name' => 'title',

						),

						array(
							'type'             => 'textfield',
							"edit_field_class" => " vc_col-sm-12 vc_column wpb_el_type_textfield vc_shortcode-param",
							'heading'          => __( 'Tab ID', 'adamas-vc-shortcodes' ),
							'param_name'       => "tab_id",
							"description"      => __( 'Enter Tab ID (Note: make sure it is unique, no space and valid according to <a href="%s" target="_blank">w3c specification</a>).', "adamas-vc-shortcodes" ),
						),

						array(
							"type"       => "attach_image",
							"heading"    => __( "SubTab Background Image", "adamas-vc-shortcodes" ),
							"param_name" => "subtab_bg_image",
							"value"      => "",
						),

						array(
							"type"        => "dropdown",
							"class"       => "",
							"heading"     => __( "Icon to display:", "adamas-vc-shortcodes" ),
							"param_name"  => "icon_type",
							"value"       => array(
								__( "Font Icon Manager", "adamas-vc-shortcodes" ) => "selector",
								__( "Custom Image Icon", "adamas-vc-shortcodes" ) => "custom",
							),
							"group"       => "Icon",
							"description" => __( "Use an existing font icon or upload a custom image.", "adamas-vc-shortcodes" )
						),
						array(
							"type"        => "ult_img_single",
							"class"       => "",
							"heading"     => __( "Upload Image Icon:", "adamas-vc-shortcodes" ),
							"param_name"  => "icon_img",
							"value"       => "",
							"group"       => "Icon",
							"description" => __( "Upload the custom image icon.", "adamas-vc-shortcodes" ),
							"dependency"  => array( "element" => "icon_type", "value" => array( "custom" ) ),
						),
						array(
							"type"        => "icon_manager",
							"class"       => "",
							"heading"     => __( "Select Icon ", "smile" ),
							"param_name"  => "icon",
							"value"       => "",
							"group"       => "Icon",
							"description" => __( "Click and select icon of your choice. If you can't find the one that suits for your purpose, you can <a href='admin.php?page=bsf-font-icon-manager' target='_blank'>add new here</a>.", "smile" ),
							//"dependency" => Array("element" => "font_icons_position","value" => array("Right","Left","Top","Bottom")),
						),


						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'ul_sub_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' ),
							//"group" => "General ",
						),

					),

				) );

			}


		}//end of vcmap function


	}

	function ultimate_tabs() {

		Ultimate_VC_Addons::ultimate_register_style( 'ult_tabs', 'tabs' );
		Ultimate_VC_Addons::ultimate_register_style( 'ult_tabs_acordian', 'tabs-accordion' );

		Ultimate_VC_Addons::ultimate_register_script( 'ult_tabs_acordian_js', 'tabs-accordion', false, array( 'jquery' ), ULTIMATE_VERSION, true );

		Ultimate_VC_Addons::ultimate_register_script( 'ult_tabs_rotate', 'tabs', false, array( 'jquery' ), ULTIMATE_VERSION, true );
	}

	function ultimate_tabs_admin() {
		$screen    = get_current_screen();
		$screen_id = $screen->base;
		if ( $screen_id !== 'post' ) {
			return false;
		}
		wp_register_script( 'tab-js-1', UAVC_URL . 'admin/vc_extend/js/ult_tab_admin_enqueue_js.js', array( 'jquery' ), ULTIMATE_VERSION, true );
		wp_register_script( 'tab-js-2', UAVC_URL . 'admin/vc_extend/js/single_element_js.js', array( 'jquery' ), ULTIMATE_VERSION, true );

		wp_enqueue_script( 'tab-js-1' );
		wp_enqueue_script( 'tab-js-2' );
		//wp_enqueue_style('css-1',plugins_url( '../admin/vc_extend/css/sub-tab.css', __FILE__ ));
	}
}

if ( class_exists( 'ULT_TAB_ELEMENT' ) ) {

	$ULT_TAB_ELEMENT = new ULT_TAB_ELEMENT;

}

if ( class_exists( "WPBakeryShortCode" ) ) {
	// Class Name should be WPBakeryShortCode_Your_Short_Code
	// See more in vc_composer/includes/classes/shortcodes/shortcodes.php
	class WPBakeryShortCode_ULT_TAB_ELEMENT extends WPBakeryShortCode {
		static $filter_added = false;
		protected $controls_css_settings = 'out-tc vc_controls-content-widget';
		protected $controls_list = array( 'edit', 'clone', 'delete' );

		public function __construct( $settings ) {
			parent::__construct( $settings ); // !Important to call parent constructor to active all logic for shortcode.
			if ( ! self::$filter_added ) {
				$this->addFilter( 'vc_inline_template_content', 'setCustomTabId' );
				self::$filter_added = true;
			}
		}

		public function contentAdmin( $atts, $content = null ) {
			$width                = $custom_markup = '';
			$shortcode_attributes = array( 'width' => '1/1' );
			foreach ( $this->settings['params'] as $param ) {
				if ( $param['param_name'] != 'content' ) {
					//$shortcode_attributes[$param['param_name']] = $param['value'];
					if ( isset( $param['value'] ) && is_string( $param['value'] ) ) {
						$shortcode_attributes[ $param['param_name'] ] = __( $param['value'], "adamas-vc-shortcodes" );
					} elseif ( isset( $param['value'] ) ) {
						$shortcode_attributes[ $param['param_name'] ] = $param['value'];
					}
				} else if ( $param['param_name'] == 'content' && $content == null ) {
					//$content = $param['value'];
					$content = __( $param['value'], "adamas-vc-shortcodes" );
				}
			}
			extract( shortcode_atts(
				$shortcode_attributes
				, $atts ) );

			// Extract tab titles

			preg_match_all( '/vc_tab title="([^\"]+)"(\stab_id\=\"([^\"]+)\"){0,1}/i', $content, $matches, PREG_OFFSET_CAPTURE );

			$output     = '';
			$tab_titles = array();

			if ( isset( $matches[0] ) ) {
				$tab_titles = $matches[0];
			}
			$tmp = '';
			if ( count( $tab_titles ) ) {
				$tmp .= '<ul class="clearfix tabs_controls">';
				foreach ( $tab_titles as $tab ) {
					preg_match( '/title="([^\"]+)"(\stab_id\=\"([^\"]+)\"){0,1}/i', $tab[0], $tab_matches, PREG_OFFSET_CAPTURE );
					if ( isset( $tab_matches[1][0] ) ) {
						$tmp .= '<li><a href="#tab-' . ( isset( $tab_matches[3][0] ) ? $tab_matches[3][0] : sanitize_title( $tab_matches[1][0] ) ) . '">' . $tab_matches[1][0] . '</a></li>';

					}
				}
				$tmp .= '</ul>' . "\n";
			} else {
				$output .= do_shortcode( $content );
			}


			$elem = $this->getElementHolder( $width );

			$iner = '';
			foreach ( $this->settings['params'] as $param ) {
				$custom_markup = '';
				$param_value   = isset( $param['param_name'] ) ? $param['param_name'] : '';
				if ( is_array( $param_value ) ) {
					// Get first element from the array
					reset( $param_value );
					$first_key   = key( $param_value );
					$param_value = $param_value[ $first_key ];
				}
				$iner .= $this->singleParamHtmlHolder( $param, $param_value );
			}
			//$elem = str_ireplace('%wpb_element_content%', $iner, $elem);

			if ( isset( $this->settings["custom_markup"] ) && $this->settings["custom_markup"] != '' ) {
				if ( $content != '' ) {
					$custom_markup = str_ireplace( "%content%", $tmp . $content, $this->settings["custom_markup"] );
				} else if ( $content == '' && isset( $this->settings["default_content_in_template"] ) && $this->settings["default_content_in_template"] != '' ) {
					$custom_markup = str_ireplace( "%content%", $this->settings["default_content_in_template"], $this->settings["custom_markup"] );
				} else {
					$custom_markup = str_ireplace( "%content%", '', $this->settings["custom_markup"] );
				}
				//$output .= do_shortcode($this->settings["custom_markup"]);
				$iner .= do_shortcode( $custom_markup );
			}
			$elem   = str_ireplace( '%wpb_element_content%', $iner, $elem );
			$output = $elem;

			return $output;
		}

		public function getTabTemplate() {
			return '<div class="wpb_template">' . do_shortcode( '[single_tab title="Tab" tab_id=""   icon_type="" icon="" icon_color="" icon_hover_color="" icon_size="15px" icon_background_color=""][/single_tab]' ) . '</div>';
		}

		public function setCustomTabId( $content ) {
			return preg_replace( '/tab\_id\=\"([^\"]+)\"/', 'tab_id="$1-' . time() . '"', $content );

		}


	}//end of tabclass


//	} // End Class

	define( 'ULT_TAB_TITLE', __( "Tab", "adamas-vc-shortcodes" ) );
	if ( function_exists( 'vc_path_dir' ) ) {
		require_once vc_path_dir( 'SHORTCODES_DIR', 'vc-column.php' );
	}

	if ( class_exists( 'WPBakeryShortCode_VC_Column' ) ) {
		class WPBakeryShortCode_SINGLE_TAB extends WPBakeryShortCode_VC_Column {

			protected $controls_css_settings = 'tc vc_control-container';
			protected $controls_list = array( 'add', 'edit', 'clone', 'delete' );
			//protected $controls_template_file = 'editors/partials/backend_controls_tab.tpl.php';

			//protected $controls_template_file = 'ultimate_vc/include/templates/editors/partials/backend_controls_tab.tpl.php';

			protected $predefined_atts = array(
				'tab_id'       => ULT_TAB_TITLE,
				'title'        => '',
				//'font_icons_position'=>'',
				'icon_type'    => '',
				'icon'         => '',
				'ul_sub_class' => '',
			);


			public function __construct( $settings ) {
				parent::__construct( $settings );

			}

			public function customAdminBlockParams() {
				return ' id="tab-' . esc_attr( $this->atts['tab_id'] ) . '"';
			}

			public function mainHtmlBlockParams( $width, $i ) {
				return 'data-element_type="' . esc_attr( $this->settings["base"] ) . '" class="wpb_' . esc_attr( $this->settings['base'] ) . ' wpb_sortable wpb_content_holder"' . $this->customAdminBlockParams();
			}

			public function containerHtmlBlockParams( $width, $i ) {
				return 'class="wpb_column_container vc_container_for_children"';
			}

			public function getColumnControls( $controls, $extended_css = '' ) {

				return $this->getColumnControlsModular( $extended_css );
			}

		}
	}
}






//add_shortcode('ult_tab_element',array($this,'ultimate_tab_shortcode'));
