/*
 * Pages Module Masonry
 */
(function ($) {
    "use strict";
    $.fn.StPagesModule = (function (pages_module_layout) {

        if (!pages_module_layout || pages_module_layout === '')
            pages_module_layout = 'fitRows';

        var $window = $(window);
        var $posts = $('.st-pages-grid-items');
        var isotopeInit;

        if ($('body').hasClass('rtl')) {
            isotopeInit = function () {
                $posts.isotope({
                    isOriginLeft: false,
                    layoutMode: pages_module_layout,
                    masonry: {},
                    itemSelector: '.st-pages-grid-item',
                    resizable: true
                });
                $.fn.matchHeight._update();
            };
        } else {
            isotopeInit = function () {
                $posts.isotope({
                    layoutMode: pages_module_layout,
                    masonry: {},
                    itemSelector: '.st-pages-grid-item',
                    resizable: true
                });
                $.fn.matchHeight._update();
            };
        }

        $posts.imagesLoaded(function () {
            isotopeInit();
            $window.on('load', isotopeInit);
            $window.on('resize', isotopeInit);
        });

    });
})(jQuery);