(function ($) {
    "use strict";
    $(document).ready(function () {
        var pageNum = parseInt(st_ajax_data.startPage) + 1;
        var max = parseInt(st_ajax_data.maxPages);
        var nextLink = st_ajax_data.nextLink;
        var container = st_ajax_data.container;
        var $container = $(container);
        var $loadmorebutton = $('#st-load-more');
        var $loadmoreanimation = $('.st-load-more-animation');

        if (pageNum > max) {
            $loadmorebutton.addClass('no-more').text(st_ajax_data.noMore);
        }

        function removeLoad() {
            $loadmoreanimation.removeClass('active');
            $loadmorebutton.removeClass('loading');
        }

        $loadmorebutton.on('click', function (e) {
            e.preventDefault();
            if (pageNum <= max) {
                $(this).addClass('loading');
                $loadmoreanimation.addClass('active');
                $.ajax({
                    type: 'GET',
                    url: nextLink,
                    dataType: 'html',
                    complete: function (XMLHttpRequest) {
                        pageNum++;
                        if (nextLink.indexOf('paged') != -1) {
                            nextLink = nextLink.replace(/\paged\=[0-9]?/, 'paged=' + pageNum);
                        } else {
                            nextLink = nextLink.replace(/\/page\/[0-9]?/, '/page/' + pageNum);
                        }
                        $(XMLHttpRequest.responseText).find(container).children().each(function () {
                            var $newItems = $(this);
                            $newItems.imagesLoaded(function () {
                                $container.isotope('insert', $newItems);
                                removeLoad();
                            });
                        });
                        if (pageNum > max) {
                            $loadmorebutton.addClass('no-more').text(st_ajax_data.noMore);
                        }
                    }
                });
            }
        });
    });
})(jQuery);