<?php if ( post_password_required() ) : ?>
    <div class="comments" id="comments">
        <div class="comment-alert">
			<?php esc_html_e( 'This post is password protected. Please, enter the password to read comments.', 'adamas' ); ?>
        </div>
    </div><!-- /#comments -->
	<?php
	return;
endif;
?>


<?php if ( have_comments() ) : ?>
    <div class="comments" id="comments">
        <div class="comments-count"><i class="st-h-before"><i></i><i><i></i></i><i></i><i></i></i>
			<?php printf( _n( '1 comment for this post', '%1$s comments for this post', get_comments_number(), 'adamas' ), number_format_i18n( get_comments_number() ) ); ?>
            <i class="st-h-after"><i></i></i>
        </div>

        <ol class="comment-list">
			<?php wp_list_comments( array( 'callback' => 'st_adamas_comment_template' ) ); ?>
        </ol>

		<?php if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ) : ?>

            <nav class="page-nav">
                <span class="older"><?php previous_comments_link( esc_html__( 'Older comments', 'adamas' ) ); ?></span>
                <span class="newer"><?php next_comments_link( esc_html__( 'Newer comments', 'adamas' ) ); ?></span>
            </nav>

		<?php endif; // check for comment navigation ?>

		<?php if ( ! comments_open() && ! is_page() && post_type_supports( get_post_type(), 'comments' ) ) : ?>
		<?php endif; ?>

    </div><!-- comments -->

<?php endif; ?>

<?php if ( comments_open() ): ?>

    <div class="comment-form" id="respond">
		<?php if ( get_option( 'comment_registration' ) && ! is_user_logged_in() ) : ?>

            <div><?php printf( wp_kses( __( 'You must be <a href="%s">logged in</a> to post a comment.', 'adamas' ), array( 'a' => array( 'href' => array() ) ) ), wp_login_url( get_permalink() ) ); ?></div>

		<?php else : ?>

        <div class="comment-reply">
			<?php comment_form_title( esc_html__( 'Leave your comment', 'adamas' ), esc_html__( 'Leave your comment to %s', 'adamas' ) ); ?>
			<?php if ( ! is_user_logged_in() ) : ?>
                <span class="comment-reply-info"><?php esc_html_e( 'Required fields are marked *', 'adamas' ); ?></span>
			<?php endif; ?>
        </div>

        <div class="comment-cancel-reply"><?php cancel_comment_reply_link(); ?></div>

		<?php if ( is_user_logged_in() ){ ?>
        <div class="comment-logged-in"><?php printf( wp_kses( __( 'Logged in as <a href="%s/wp-admin/profile.php" class="user-name">%s</a>.', 'adamas' ), array(
				'a' => array(
					'href'  => array(),
					'class' => array()
				)
			) ), get_option( 'siteurl' ), $user_identity ); ?>
            <a href="<?php echo wp_logout_url( get_permalink() ); ?>"
               title="<?php esc_attr_e( 'Log out', 'adamas' ); ?>"
               class="log-out"><?php esc_html_e( 'Log out', 'adamas' ); ?></a>
        </div>
        <form action="<?php echo get_option( 'siteurl' ); ?>/wp-comments-post.php" method="post" id="commentform">
			<?php } else { ?>

            <form action="<?php echo get_option( 'siteurl' ); ?>/wp-comments-post.php" method="post" id="commentform">

                <div class="comment-input-wrap st-4 col">
                    <input type="text"
                           placeholder="<?php esc_attr_e( 'Name', 'adamas' );
					       if ( $req ) {
						       esc_attr_e( '*', 'adamas' );
					       } ?>" class="name" name="author" id="author"
                           value="<?php echo esc_attr( $comment_author ); ?>"
                           tabindex="1" <?php if ( $req ) {
						echo "aria-required='true'";
					} ?>></div>
                <div class="comment-input-wrap st-4 col">
                    <input type="email" placeholder="<?php esc_attr_e( 'Email', 'adamas' );
					if ( $req ) {
						esc_attr_e( '*', 'adamas' );
					} ?>" class="email" name="email" id="email"
                           value="<?php echo esc_attr( $comment_author_email ); ?>"
                           tabindex="2" <?php if ( $req ) {
						echo "aria-required='true'";
					} ?>></div>
                <div class="comment-input-wrap st-4 col website">
                    <input type="url"
                           placeholder="<?php esc_attr_e( 'Website', 'adamas' ); ?>"
                           class="website" name="url" id="url"
                           value="<?php echo esc_attr( $comment_author_url ); ?>"
                           size="22" tabindex="3"></div>
				<?php } ?>
                <div class="comment-textarea-wrap st-12 col">
                    <textarea rows="8" name="comment" id="comment" tabindex="4" placeholder="<?php esc_attr_e( 'Comment', 'adamas' ); ?>"></textarea>
                </div>

                <button name="submit" class="button" tabindex="5">
                    <span class="st-comment-button-text"><?php esc_html_e( 'Post comment', 'adamas' ); ?></span>
                    <span class="st-comment-button-icon"><i class="fa fa-angle-right" aria-hidden="true"></i></span>
                </button>

				<?php comment_id_fields(); ?>
				<?php do_action( 'comment_form', $post->ID ); ?>
            </form>
			<?php endif; // If registration required and not logged in ?>
    </div>
<?php endif; // if you delete this the sky will fall on your head ?>

<?php
