<!DOCTYPE html>
<html class="no-ie" <?php language_attributes(); ?>>
<head>
    <meta charset="<?php bloginfo( 'charset' ); ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
	<?php wp_head(); ?>
</head>
<?php
global $st_adamas;
$boxed_style = '';

if ( ! empty( $st_adamas['boxed_bg'] ) ) {
	$boxed_style .= 'style="';
	if ( isset( $st_adamas['boxed_bg']['background-color'] ) && ! empty( $st_adamas['boxed_bg']['background-color'] ) ) {
		$boxed_style .= 'background-color:' . esc_attr( $st_adamas['boxed_bg']['background-color'] ) . ';';
	}
	if ( isset( $st_adamas['boxed_bg']['background-image'] ) && ! empty( $st_adamas['boxed_bg']['background-image'] ) ) {
		$boxed_style .= 'background-image:url(' . esc_url( $st_adamas['boxed_bg']['background-image'] ) . ');';
	}
	if ( isset( $st_adamas['boxed_bg']['background-repeat'] ) && ! empty( $st_adamas['boxed_bg']['background-repeat'] ) ) {
		$boxed_style .= 'background-repeat:' . esc_attr( $st_adamas['boxed_bg']['background-repeat'] ) . ';';
	}
	if ( isset( $st_adamas['boxed_bg']['background-position'] ) && ! empty( $st_adamas['boxed_bg']['background-position'] ) ) {
		$boxed_style .= 'background-position:' . esc_attr( $st_adamas['boxed_bg']['background-position'] ) . ';';
	}
	if ( isset( $st_adamas['boxed_bg']['background-size'] ) && ! empty( $st_adamas['boxed_bg']['background-size'] ) ) {
		$boxed_style .= 'background-size:' . esc_attr( $st_adamas['boxed_bg']['background-size'] ) . ';';
	}
	if ( isset( $st_adamas['boxed_bg']['background-attachment'] ) && ! empty( $st_adamas['boxed_bg']['background-attachment'] ) ) {
		$boxed_style .= 'background-attachment:' . esc_attr( $st_adamas['boxed_bg']['background-attachment'] ) . ';';
	}
	$boxed_style .= '"';
}

if ( isset( $st_adamas['header_layout'] ) ):
	$header_layout = $st_adamas['header_layout'];
endif;
if ( $header_layout == '3' || $header_layout == '4' || $header_layout == '5' || $header_layout == '6' ) {
	$header = 'enl-padding';
} else {
	$header = 'padding';
}
?>

<body <?php body_class(); ?> <?php echo '' !== $boxed_style ? $boxed_style : ''; ?>>
<?php wp_body_open(); ?>
<div class="js-animsition animsition" data-animsition-in-class="fade-in" data-animsition-out-class="fade-out">
	<?php if ( ! is_page_template( 'page-templates/blank-page.php' ) ) { ?>
		<?php get_template_part( 'templates/header/header' ); ?>
	<?php } ?>
    <div id="main-container" class="<?php echo esc_attr( $header ); ?>">