<?php
global $st_adamas;

$blog_page_sharing = $st_adamas['blog_page_sharing']['enabled'];
$shares            = array();

foreach ( $blog_page_sharing as $share_key => $share_value ) {
	if ( $share_key == 'placebo' ) {
		continue;
	}
	$shares[] = $share_key;
}

$shares = array_reverse( $shares );

?>

<article <?php post_class(); ?>>
    <div class="post-inner">
		<?php
		switch ( true ) {
			// Gallery Post Format
			case has_post_format( 'gallery' ):
				get_template_part( 'templates/post', 'gallery' );
				break;
			// Video Post Format
			case has_post_format( 'video' ):
				get_template_part( 'templates/post', 'video' );
				break;
			// Audio Post Format
			case has_post_format( 'audio' ):
				get_template_part( 'templates/post', 'audio' );
				break;
			// Quote Post Format
			case has_post_format( 'quote' ):
				get_template_part( 'templates/post', 'quote' );
				break;
			// Standard Post
			default:
				get_template_part( 'templates/post', 'standard' );
		}
		?>
		<?php
		if ( ! has_post_format( 'quote' ) ) { ?>
            <div class="post-title">
                <a href="<?php the_permalink(); ?>"><h3><?php
						$title = get_the_title();
						if ( empty( $title ) ) {
							the_time( get_option( 'date_format' ) );
						} else {
							echo esc_html( $title );
						}
						?>
                    </h3>
                </a>
            </div>
            <div class="post-meta">
				<?php
				$categories = get_the_category();
				$output     = '';
				?>
                <div class="post-category">
					<?php
					foreach ( $categories as $category ) {
						$output .= '<div class="post-category-single"><a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . sprintf( esc_attr__( 'View all posts in %s', 'adamas' ), $category->name ) . '">' . esc_html( $category->name ) . '</a></div>';
					}
					echo trim( $output );
					?>
                </div>
                <time class="post-time" datetime="<?php the_time( 'Y-m-d' ); ?>">
					<?php echo get_the_date( get_option( 'date_format' ) ); ?>
                </time>
                <div class="post-author">
                    <span><?php esc_html_e( 'By', 'adamas' ) ?>
                        :</span> <?php if ( ( get_the_author_meta( 'display_name', $post->post_author ) ) != '0' ) { ?>
                        <span><?php echo get_the_author_meta( 'display_name', $post->post_author ); ?></span>
					<?php } else { ?>
                        <span><?php echo get_the_author(); ?></span>
					<?php } ?>
                </div>
                <div class="post-comments-amount">
                    <span><?php esc_html_e( 'Comments', 'adamas' ) ?>:</span>
                    <span><?php comments_number( '0', '1', '%' ); ?></span>
                </div>
                <div class="post-likes-amount">
                    <span><?php esc_html_e( 'Likes', 'adamas' ) ?>:</span>
                    <span><?php echo st_adamas_get_simple_likes_count( get_the_ID() ); ?></span>
                </div>
            </div>
            <div class="post-content">
				<?php the_excerpt(); ?>
            </div>
		<?php } ?>
    </div>
    <div class="post-link">
        <a href="<?php echo get_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php esc_html_e( 'Read More', 'adamas' ); ?></a>
    </div>
    <div class="post-sharing">
        <div class="post-sharing-inner" data-link="<?php echo esc_url( the_permalink() ); ?>"
             data-shares-count="<?php echo esc_attr( count( $shares ) ); ?>"
             data-shares="<?php echo esc_attr( json_encode( $shares ) ); ?>"></div>
        <div class="share"><?php esc_html_e( 'Share', 'adamas' ); ?></div>
    </div>
</article>