<article <?php post_class(); ?>>
    <div class="post-inner">
        <div class="post-media">
			<?php
			switch ( true ) {
				// Gallery Post Format
				case has_post_format( 'gallery' ):
					get_template_part( 'templates/post', 'gallery' );
					break;
				// Video Post Format
				case has_post_format( 'video' ):
					get_template_part( 'templates/post', 'video' );
					break;
				// Audio Post Format
				case has_post_format( 'audio' ):
					get_template_part( 'templates/post', 'audio' );
					break;
				// Quote Post Format
				case has_post_format( 'quote' ):
					get_template_part( 'templates/post', 'quote' );
					break;
				// Standard Post
				default:
					get_template_part( 'templates/post', 'standard' );
			}
			?>
        </div>
		<?php
		if ( ! has_post_format( 'quote' ) ) { ?>
            <div class="post-title">
                <a href="<?php the_permalink(); ?>"><h3><?php
						$title = get_the_title();
						if ( empty( $title ) ) {
							the_time( get_option( 'date_format' ) );
						} else {
							the_title();
						}
						?>
                    </h3>
                </a>
            </div>
            <div class="post-meta">
				<?php
				if ( get_post_type() == 'post' ) {
					$categories = get_the_category();
					$output     = '';
					?>
                    <div class="post-category">
						<?php
						foreach ( $categories as $category ) {
							$output .= '<div class="post-category-single"><a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . sprintf( esc_attr__( 'View all posts in %s', 'adamas' ), $category->name ) . '">' . esc_html( $category->name ) . '</a></div>';
						}
						echo trim( $output );
						?>
                    </div>
				<?php } ?>
                <time class="post-time" datetime="<?php the_time( 'Y-m-d' ); ?>">
					<?php echo get_the_date( get_option( 'date_format' ) ); ?>
                </time>
                <div class="post-author">
					<?php esc_html_e( 'By', 'adamas' ) ?>
                    : <?php if ( get_the_author_meta( 'display_name', $post->post_author ) !== '0' ) {
						echo get_the_author_meta( 'display_name', $post->post_author );
					} else {
						echo get_the_author();
					} ?>
                </div>
				<?php if ( get_post_type() === 'post' ) { ?>
                    <div class="post-comments-amount">
						<?php esc_html_e( 'Comments', 'adamas' ) ?>: <?php comments_number( '0', '1', '%' ); ?>
                    </div>
                    <div class="post-likes-amount">
						<?php esc_html_e( 'Likes', 'adamas' ) ?>
                        : <?php echo st_adamas_get_simple_likes_count( get_the_ID() ); ?>
                    </div>
				<?php } ?>
            </div>
            <div class="post-content">
				<?php
				if ( has_excerpt() ) {
					the_excerpt();
				}
				?>
            </div>
		<?php } ?>
    </div>
    <div class="post-link">
        <a href="<?php echo get_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php esc_html_e( 'Read More', 'adamas' ); ?></a>
    </div>
    <div class="post-sharing">
        <div class="post-sharing-inner"></div>
        <div class="share"><?php esc_html_e( 'Share', 'adamas' ); ?></div>
    </div>
</article>