<?php
global $st_adamas, $post;

if ( isset( $st_adamas['topbar_enable'] ) && $st_adamas['topbar_enable'] === '1' ):
	$topbar = 'with-topbar';
else :
	$topbar = '';
endif;

?>
<header id="header-container" <?php echo( esc_attr( $topbar ) !== '' ? 'class="' . esc_attr( $topbar ) . '"' : '' ); ?>>
    <div id="header" class="header-third">
        <div class="header-wrapper-mobile">
            <div class="row">
                <div class="st-12 col">
                    <div class="mobile-menu-icon" id="icon-mobile-menu">
                        <a id="mobile-menu-button" href="#mob-menu">
                            <div class="icon-bar-top"></div>
                            <div class="icon-bar-middle"></div>
                            <div class="icon-bar-bottom"></div>
                        </a>
                    </div>
                    <div class="logo-mobile-container">
						<?php if ( isset( $st_adamas['custom_logo_mobile']['url'] ) && $st_adamas['custom_logo_mobile']['url'] ) : ?>
                            <a href="<?php echo site_url(); ?>">
                                <img src="<?php echo esc_url( $st_adamas['custom_logo_mobile']['url'] ); ?>"
                                     alt="<?php echo esc_attr( get_bloginfo( 'name' ) ); ?>">
                            </a>
						<?php else :
							$site_title = get_bloginfo( 'name' );
							$site_description = get_bloginfo( 'description' );
							?>
                            <h1 class="st-site-title"><?php echo esc_html( $site_title ); ?></h1>
                            <span class="st-site-description"><?php echo esc_html( $site_description ); ?></span>
						<?php endif; ?>
                    </div>
                    <div class="header-mobile-menu" id="mob-menu">
						<?php wp_nav_menu( array(
								'theme_location'  => 'primary_navigation',
								'container'       => 'nav',
								'container_class' => 'nav',
							)
						); ?>
                    </div>
					<?php if ( isset( $st_adamas['header_search'] ) && ( $st_adamas['header_search'] ) == 1 ) { ?>
                        <div class="search-icon-mobile">
                            <i class="fa fa-search"></i>
                        </div>
                        <div class="st-header-search-mobile">
							<?php get_search_form(); ?>
                        </div>
					<?php } ?>
                </div>
            </div>
        </div>
		<?php
		if ( isset( $st_adamas['topbar_enable'] ) && ( $st_adamas['topbar_enable'] ) == 1 ):
			get_template_part( 'templates/header/topbar', 'third' );
			$topbar_enabled = ' topbar-enabled';
		else :
			$topbar_enabled = ' ';
		endif;
		?>

		<?php
		if ( isset( $st_adamas['header_bg_check'] ) && $st_adamas['header_bg_check'] == 1 && ! is_home() && is_front_page() ):
			$transparent = ' transparent';
		else :
			$transparent = ' ';
		endif;
		?>

		<?php

		if ( get_post_meta( $post->ID, 'st_transparent_header', true ) === 'enable' ) {
			$transparent = ' transparent';
		}

		?>

		<?php
		if ( isset( $st_adamas['sticky_nav'] ) && ( $st_adamas['sticky_nav'] ) == 1 ):
			$sticky = ' sticky';
		else :
			$sticky = ' ';
		endif;
		?>
        <div class="header-wrapper<?php echo "{$sticky} {$topbar_enabled} {$transparent}"; ?>">
            <div class="row-full-width">
                <div class="st-12 col">
                    <div class="header-wrapper-inner">
                        <div class="header-lang-social">
                            <div class="header-social">
                                <ul>
									<?php if ( ! empty( $st_adamas['socials_facebook'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_facebook'] ); ?>" target="_blank"><i class="fa fa-facebook"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_twitter'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_twitter'] ); ?>" target="_blank"><i class="fa fa-twitter"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_instagram'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_instagram'] ); ?>" target="_blank"><i class="fa fa-instagram"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_linkedin'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_linkedin'] ); ?>" target="_blank"><i class="fa fa-linkedin"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_gplus'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_gplus'] ); ?>" target="_blank"><i class="fa fa-google-plus"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_pinterest'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_pinterest'] ); ?>" target="_blank"><i class="fa fa-pinterest-p"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_youtube'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_youtube'] ); ?>" target="_blank"><i class="fa fa-youtube-play"></i></a></li>
									<?php endif; ?>
									<?php if ( ! empty( $st_adamas['socials_vk'] ) ) : ?>
                                        <li><a href="<?php echo esc_url( $st_adamas['socials_vk'] ); ?>" target="_blank"><i class="fa fa-vk"></i></a></li>
									<?php endif; ?>
                                </ul>
                            </div>
                        </div>
                        <div class="logo-container">
                            <span class="img-align"></span>
                            <a href="<?php echo site_url(); ?>">
								<?php if ( get_post_meta( $post->ID, 'st_transparent_header', true ) === 'enable' || ( ! is_home() && is_front_page() && isset( $st_adamas['custom_logo_transparent']['url'] ) && $st_adamas['custom_logo_transparent']['url'] ) ) : ?>
                                    <img class="transparent" src="<?php echo esc_url( $st_adamas['custom_logo_transparent']['url'] ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name' ) ); ?>"/>
                                    <img src="<?php echo esc_url( $st_adamas['custom_logo']['url'] ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name' ) ); ?>"/>
								<?php elseif ( isset( $st_adamas['custom_logo']['url'] ) && $st_adamas['custom_logo']['url'] ) : ?>
                                    <img src="<?php echo esc_url( $st_adamas['custom_logo']['url'] ); ?>" alt="<?php echo esc_attr( get_bloginfo( 'name' ) ); ?>"/>
								<?php else : ?>
									<?php
									$site_title       = get_bloginfo( 'name' );
									$site_description = get_bloginfo( 'description' );
									?>
                                    <h1 class="st-site-title"><?php echo esc_html( $site_title ); ?></h1>
                                    <span class="st-site-description"><?php echo esc_html( $site_description ); ?></span>
								<?php endif; ?>
                            </a>
                        </div>
                        <div class="st-header-icons">
							<?php if ( isset( $st_adamas['header_search'] ) && ( $st_adamas['header_search'] ) == 1 ) { ?>
                                <div class="st-search-icon">
                                    <i class="fa fa-search" aria-hidden="true"></i>
                                    <div class="st-header-search">
										<?php get_search_form(); ?>
                                    </div>
                                </div>
							<?php } ?>
							<?php if ( class_exists( 'woocommerce' ) ) { ?>
                                <div class="st-account-icon">
                                    <a href="<?php echo get_permalink( get_option( 'woocommerce_myaccount_page_id' ) ); ?>">
                                        <i class="fa fa-user" aria-hidden="true"></i>
                                    </a>
                                </div>
							<?php } ?>
							<?php if ( class_exists( 'YITH_WCWL' ) ) { ?>
                                <div class="st-wishlist-icon">
									<?php $url = YITH_WCWL()->get_wishlist_url(); ?>
                                    <a href="<?php echo esc_url( $url ); ?>">
                                        <i class="fa fa-heart" aria-hidden="true"></i>
                                    </a>
                                </div>
							<?php } ?>
							<?php if ( class_exists( 'woocommerce' ) ) { ?>
                                <div class="st-cart-icon">
                                    <i class="fa fa-shopping-cart" aria-hidden="true"></i>
                                    <div class="widget_shopping_cart_content">
                                        <ul class="cart_list product_list_widget">
											<?php if ( ! wc()->cart->is_empty() ) : ?>
												<?php
												foreach ( wc()->cart->get_cart() as $cart_item_key => $cart_item ) {
													$_product   = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
													$product_id = apply_filters( 'woocommerce_cart_item_product_id', $cart_item['product_id'], $cart_item, $cart_item_key );

													if ( $_product && $_product->exists() && $cart_item['quantity'] > 0 && apply_filters( 'woocommerce_widget_cart_item_visible', true, $cart_item, $cart_item_key ) ) {
														$product_name      = apply_filters( 'woocommerce_cart_item_name', $_product->get_name(), $cart_item, $cart_item_key );
														$thumbnail         = apply_filters( 'woocommerce_cart_item_thumbnail', $_product->get_image(), $cart_item, $cart_item_key );
														$product_price     = apply_filters( 'woocommerce_cart_item_price', wc()->cart->get_product_price( $_product ), $cart_item, $cart_item_key );
														$product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $cart_item ) : '', $cart_item, $cart_item_key );
														?>
                                                        <li class="woocommerce-mini-cart-item <?php echo esc_attr( apply_filters( 'woocommerce_mini_cart_item_class', 'mini_cart_item', $cart_item, $cart_item_key ) ); ?>">
															<?php
															echo apply_filters( 'woocommerce_cart_item_remove_link', sprintf(
																'<a href="%s" class="remove" aria-label="%s" data-product_id="%s" data-product_sku="%s">&times;</a>',
																esc_url( wc_get_cart_remove_url( $cart_item_key ) ),
																__( 'Remove this item', 'adamas' ),
																esc_attr( $product_id ),
																esc_attr( $_product->get_sku() )
															), $cart_item_key );
															?>
															<?php if ( ! $_product->is_visible() ) : ?>
																<?php echo str_replace( array(
																		'http:',
																		'https:'
																	), '', $thumbnail ) . '<span class="product-title">' . wp_trim_words( $product_name, 4, '...' ) . '</span>' . '&nbsp;'; ?>
															<?php else : ?>
                                                                <a href="<?php echo esc_url( $product_permalink ); ?>">
																	<?php echo str_replace( array(
																			'http:',
																			'https:'
																		), '', $thumbnail ) . '<span class="product-title">' . wp_trim_words( $product_name, 4, '...' ) . '</span>' . '&nbsp;'; ?>
                                                                </a>
															<?php endif; ?>
															<?php echo wc_get_formatted_cart_item_data( $cart_item ); ?>

															<?php echo apply_filters( 'woocommerce_widget_cart_item_quantity', '<span class="quantity">' . sprintf( '%s &times; %s', $cart_item['quantity'], $product_price ) . '</span>', $cart_item, $cart_item_key ); ?>
                                                        </li>
														<?php
													}
												}
												?>
											<?php else : ?>
                                                <li class="empty"><?php esc_html_e( 'No products in the cart.', 'adamas' ); ?></li>
											<?php endif; ?>
                                        </ul><!-- end product list -->
										<?php if ( ! wc()->cart->is_empty() ) : ?>
                                            <p class="total"><strong><?php esc_html_e( 'CART SUBTOTAL', 'adamas' ); ?>:</strong> <?php echo wc()->cart->get_cart_subtotal(); ?></p>
											<?php do_action( 'woocommerce_widget_shopping_cart_before_buttons' ); ?>
                                            <p class="buttons">
                                                <a href="<?php echo esc_url( wc_get_cart_url() ); ?>" class="button wc-forward"><?php esc_html_e( 'View Cart', 'adamas' ); ?></a>
                                                <a href="<?php echo esc_url( wc_get_checkout_url() ); ?>" class="button checkout wc-forward"><?php esc_html_e( 'Checkout', 'adamas' ); ?></a>
                                            </p>
										<?php endif; ?>
                                    </div>
									<?php global $woocommerce; ?>
                                    <div class="st-cart-count"></div>
                                </div>
							<?php } ?>
                        </div>
                    </div>
                    <div class="header-third-sep"></div>
					<?php wp_nav_menu( array(
						'theme_location'  => 'primary_navigation',
						'container'       => 'nav',
						'container_class' => 'header-navigation',
						'menu_class'      => 'header-navigation',
					) ); ?>
                </div>
            </div>
        </div>
    </div>
</header>