<?php

if ( has_post_thumbnail() ) {
	$image_resize = true;

	$image_id  = get_post_thumbnail_id();
	$image_url = wp_get_attachment_url( $image_id );

	$width  = 900;
	$height = 400;

	$image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
	if ( ! $image ) {
		$image = $image_url;
	}
}

$video_url = get_post_meta( get_the_ID(), 'st_video_post_video_url', 1 );
if ( ! empty( $video_url ) ) {
	$video        = esc_url( $video_url );
	$video_iframe = wp_oembed_get( $video );
}

?>
<?php if ( ! empty( $video ) ) { ?>
    <div class="post-media">
        <div class="post-video">
			<?php echo str_replace( array(
				'mozallowfullscreen',
				'frameborder="0"',
				'webkitallowfullscreen'
			), ' ', $video_iframe ); ?>
        </div>
    </div>
<?php } else {
	if ( has_post_thumbnail() ) { ?>
        <div class="post-media">
            <div class="post-video">
                <img src="<?php echo esc_url( $image ); ?>" alt="<?php the_title_attribute(); ?>"/>
            </div>
        </div>
	<?php }
}