<?php

$width  = 1920;
$height = 960;

$img_array = get_post_meta( get_the_ID(), 'st_gallery_post_images', 1 );
if ( ! empty( $img_array ) ) {
	$gallery_images = $img_array;
}

if ( has_post_thumbnail() ) {
	$image_resize = true;

	$image_id  = get_post_thumbnail_id();
	$image_url = wp_get_attachment_url( $image_id );

	$image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
	if ( ! $image ) {
		$image = $image_url;
	}
}

?>

<?php
if ( ! empty( $gallery_images ) ) {
	?>
    <div class="post-gallery">
		<?php foreach ( $gallery_images as $gallery_image_id => $gallery_image_url ) {
			$image_resize = true;

			$gallery_image_alt = get_post_meta( $gallery_image_id, '_wp_attachment_image_alt', true );

			$gallery_image = st_adamas_aq_resize( $gallery_image_url, $width, $height, $image_resize, true, true );
			if ( ! $gallery_image ) {
				$gallery_image = $gallery_image_url;
			}
			?>
            <img src="<?php echo esc_url( $gallery_image ); ?>" alt="<?php echo esc_attr( $gallery_image_alt ); ?>"/>
		<?php } ?>
    </div>
    <div class="post-gallery-progress">
        <div class="progress"></div>
    </div>
<?php } else { ?>
    <div class="post-thumbnail">
		<?php if ( has_post_thumbnail() ) { ?>
            <img src="<?php echo esc_url( $image ); ?>" alt="<?php the_title_attribute(); ?>"/>
		<?php } ?>
    </div>
<?php }