<?php
global $st_adamas;

if ( has_post_thumbnail() ) {
	$thumbnail        = get_post_thumbnail_id( $post->ID );
	$image_url        = wp_get_attachment_url( $thumbnail );
	$title_background = 'style="background-image:url(' . esc_url( $image_url ) . ')"';
} else {
	$title_background = '';
}

if ( is_home() && get_option( 'page_for_posts' ) ) {
	$page_for_posts = get_option( 'page_for_posts', true );
	if ( has_post_thumbnail( $page_for_posts ) ) {
		$img                   = wp_get_attachment_image_src( get_post_thumbnail_id( $page_for_posts ), 'full' );
		$image_url             = $img[0];
		$blog_title_background = 'style="background-image:url(' . esc_url( $image_url ) . ')"';
	} else {
		$blog_title_background = '';
	}
}

if ( class_exists( 'woocommerce' ) && is_shop() ) {
	$shop = get_option( 'woocommerce_shop_page_id' );
	if ( has_post_thumbnail( $shop ) ) {
		$img                   = wp_get_attachment_image_src( get_post_thumbnail_id( $shop ), 'full' );
		$image_url             = $img[0];
		$shop_title_background = 'style="background-image:url(' . esc_url( $image_url ) . ')"';
	} else {
		$shop_title_background = '';
	}
}

if ( class_exists( 'woocommerce' ) && is_product_category() ) {
	$term      = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
	$img       = get_term_meta( $term->term_id, 'thumbnail_id', true );
	$image_url = wp_get_attachment_url( $img );
	if ( $image_url ) {
		$product_category_title_background = 'style="background-image:url(' . esc_url( $image_url ) . ')"';
	} else {
		$product_category_title_background = '';
	}
}

if ( is_home() && get_option( 'page_for_posts' ) ) {
	$page_title_subtitle           = get_post_meta( get_option( 'page_for_posts' ), 'st_page_title_subtitle', true );
	$title_background_check        = get_post_meta( get_option( 'page_for_posts' ), 'st_page_title_color', true );
	$title_align                   = get_post_meta( get_option( 'page_for_posts' ), 'st_page_title_align', true );
	$title_container_height        = get_post_meta( get_option( 'page_for_posts' ), 'st_title_container_height', true );
	$title_container_overlay_color = get_post_meta( get_option( 'page_for_posts' ), 'st_title_container_overlay_color', true );
} elseif ( class_exists( 'woocommerce' ) && is_shop() ) {
	$page_title_subtitle           = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_page_title_subtitle', true );
	$title_background_check        = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_page_title_color', true );
	$title_align                   = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_page_title_align', true );
	$title_container_height        = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_title_container_height', true );
	$title_container_overlay_color = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_title_container_overlay_color', true );
} elseif ( class_exists( 'woocommerce' ) && is_product_category() ) {
	$term                          = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
	$page_title_subtitle           = $term->description;
	$title_container_height        = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_title_container_height', true );
	$title_container_overlay_color = get_post_meta( get_option( 'woocommerce_shop_page_id' ), 'st_title_container_overlay_color', true );
} elseif ( is_archive() ) {
	$term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
	if ( $term && isset( $term->description ) ) {
		$page_title_subtitle = $term->description;
	} elseif ( is_post_type_archive() ) {
		$queried_object = get_queried_object();

		if ( isset( $queried_object->labels ) && isset( $queried_object->labels->description ) ) {
			$page_title_subtitle = $queried_object->labels->description;
		}
	} elseif ( is_day() ) {
		$page_title_subtitle = null;
	} elseif ( is_month() ) {
		$page_title_subtitle = null;
	} elseif ( is_year() ) {
		$page_title_subtitle = null;
	} elseif ( is_author() ) {
		$page_title_subtitle = null;
	} else {
		$page_title_subtitle = category_description();
	}
	$title_container_height = get_post_meta( get_option( 'page_for_posts' ), 'st_title_container_height', true );
	$title_align            = get_post_meta( get_option( 'page_for_posts' ), 'st_page_title_align', true );
} elseif ( is_search() ) {
	$page_title_subtitle    = null;
	$title_container_height = 'standard';
	$title_align            = get_post_meta( get_option( 'page_for_posts' ), 'st_page_title_align', true );
} else {
	$page_title_subtitle           = get_post_meta( $post->ID, 'st_page_title_subtitle', true );
	$title_background_check        = get_post_meta( $post->ID, 'st_page_title_color', true );
	$title_align                   = get_post_meta( $post->ID, 'st_page_title_align', true );
	$title_container_height        = get_post_meta( $post->ID, 'st_title_container_height', true );
	$title_container_overlay_color = get_post_meta( $post->ID, 'st_title_container_overlay_color', true );
}

if ( ! empty( $title_container_overlay_color ) ) {
	$title_container_overlay = ' style="background-color:' . esc_attr( $title_container_overlay_color ) . ';"';
} else {
	$title_container_overlay = '';
}

if ( ! empty( $title_background_check ) ) {
	$title_color = ' style="color: ' . esc_attr( $title_background_check ) . '"';
}

if ( ! empty( $title_align ) ) {
	$title_alignment = ' text-' . esc_attr( $title_align ) . '';
} else {
	$title_alignment = ' text-left';
}
?>
<div class="title-container <?php echo esc_attr( $title_container_height ); ?>" <?php echo ! empty( $title_background_check ) ? $title_color : ' style="color: #ffffff;"'; ?>>
    <div class="title-container-background" <?php
	if ( is_home() && get_option( 'page_for_posts' ) ) {
		echo ! empty( $blog_title_background ) ? $blog_title_background : '';
	} elseif ( class_exists( 'woocommerce' ) && is_shop() ) {
		echo ! empty( $shop_title_background ) ? $shop_title_background : '';
	} elseif ( class_exists( 'woocommerce' ) && is_product_category() ) {
		echo ! empty( $product_category_title_background ) ? $product_category_title_background : '';
	} elseif ( is_archive() || is_search() ) {
		echo 'style="background:' . esc_attr( $st_adamas['fifth_theme_color'] ) . '"';
	} else {
		echo ! empty( $title_background ) ? $title_background : '';
	}
	?>></div>
    <div class="title-container-overlay" <?php echo ! empty( $title_container_overlay ) ? $title_container_overlay : ''; ?>></div>
    <div class="title-container-inner <?php if ( ! empty( $page_title_subtitle ) ): ?>with-page-subtitle<?php endif; ?>">
        <div class="page-title-inner <?php echo esc_attr( $title_alignment ); ?>">
            <div class="page-title-inner-wrapper">
                <h1 class="page-title">
					<?php
					switch ( true ) {
						// Blog Page
						case ( is_home() ):
							$page_for_posts = get_option( 'page_for_posts', true );
							if ( $page_for_posts ) {
								echo esc_html( get_the_title( $page_for_posts ) );
							} else {
								esc_html_e( 'Latest Posts', 'adamas' );
							}
							break;

						// WooCommerce Shop
						case ( class_exists( 'woocommerce' ) && is_shop() ):
							echo esc_html( woocommerce_page_title( false ) );
							break;

						// Archive Page
						case ( is_archive() ):
							$term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
							if ( $term && isset( $term->name ) ) {
								echo esc_html( $term->name );
							} elseif ( is_post_type_archive() ) {
								$queried_object = get_queried_object();

								if ( isset( $queried_object->labels ) && isset( $queried_object->labels->name ) ) {
									echo esc_html( $queried_object->labels->name );
								}
							} elseif ( is_day() ) {
								printf( esc_html__( 'Day %s', 'adamas' ), get_the_date() );
							} elseif ( is_month() ) {
								printf( esc_html__( 'Month %s', 'adamas' ), get_the_date( 'F Y' ) );
							} elseif ( is_year() ) {
								printf( esc_html__( 'Year %s', 'adamas' ), get_the_date( 'Y' ) );
							} elseif ( is_author() ) {
								printf( esc_html__( 'By %s', 'adamas' ), get_the_author_meta( 'display_name', $post->post_author ) );
							} else {
								esc_html( single_cat_title() );
							}
							break;
						// Search Page
						case ( is_search() ):
							printf( esc_html__( 'Search results for %s', 'adamas' ), get_search_query() );
							break;
						// Page 404
						case ( is_404() ):
							esc_html_e( 'Nothing Found', 'adamas' );
							break;

						// Standard Page
						default:
							$title = get_the_title();
							if ( empty( $title ) ) {
								the_time( get_option( 'date_format' ) );
							} else {
								echo esc_html( $title );
							}
					} ?>
                </h1>
				<?php if ( ! empty( $page_title_subtitle ) ): ?>
                    <div class="page-subtitle">
						<?php echo esc_html( $page_title_subtitle ); ?>
                    </div>
				<?php endif; ?>
            </div>
        </div>
    </div>
	<?php st_adamas_breadcrumbs(); ?>
</div>